// SampleLibrary.cpp
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#include <Windows.h>
#include <stdio.h>
#include <tchar.h>

#include <LMCons.h> //  UNLEN

//  GetUserNameEx:

#pragma comment (lib, "Secur32.lib")

#define SECURITY_WIN32
#include <Security.h>

// ------------------------------------------------------------------------------------------------
BOOL PrintComputerName()
{
    TCHAR szBuffer[MAX_COMPUTERNAME_LENGTH + 1];
    DWORD cch = _countof(szBuffer);

    //  NetBIOS  
    BOOL bRet = GetComputerName(szBuffer, &cch);

    if (FALSE != bRet)
    {
        //      
        _tprintf(TEXT("Name: %s\n"), szBuffer);
    } // if

    return bRet;
} // PrintComputerName

// ------------------------------------------------------------------------------------------------
BOOL PrintDNSHostname()
{
    LPTSTR lpszBuffer = NULL;
    DWORD cch = 0;

    //   
    GetComputerNameEx(ComputerNamePhysicalDnsHostname, NULL, &cch);

    //    
    lpszBuffer = new TCHAR[cch];

    //  DNS  
    BOOL bRet = GetComputerNameEx(ComputerNamePhysicalDnsHostname, lpszBuffer, &cch);

    if (FALSE != bRet)
    {
        //      
        _tprintf(TEXT("Hostname: %s\n"), lpszBuffer);
    } // if

    //  ,   
    delete [] lpszBuffer;

    return bRet;
} // PrintDNSHostname

// ------------------------------------------------------------------------------------------------
BOOL PrintUserName()
{
    TCHAR szBuffer[UNLEN + 1];
    DWORD cch = _countof(szBuffer);

    //   
    BOOL bRet = GetUserName(szBuffer, &cch);

    if (FALSE != bRet)
    {
        //      
        _tprintf(TEXT("User: %s\n"), szBuffer);
    } // if

    return bRet;
} // PrintUserName

// ------------------------------------------------------------------------------------------------
BOOL PrintUserNameCompatible()
{
    TCHAR szBuffer[UNLEN + 1];
    ULONG cch = _countof(szBuffer);

    //   
    BOOLEAN bRet = GetUserNameEx(NameSamCompatible, szBuffer, &cch);

    if (FALSE != bRet)
    {
        //      
        _tprintf(TEXT("User: %s\n"), szBuffer);
    } // if

    return bRet;
} // PrintUserNameCompatible
