// Sample (listbox).cpp
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#include <Windows.h>
#include <WindowsX.h>
#include <CommCtrl.h>
#include <tchar.h>

#include "resource.h"
#include "afxres.h"

//      
#define IDC_LIST             2001

//    WM_ADDITEM,
//      
#define WM_ADDITEM           WM_USER + 1

HWND hWnd = NULL; //   

HACCEL hAccel = NULL; //    

//    
HWND hDlg = NULL;
HWND hFindDlg = NULL;

TCHAR szBuffer[100] = TEXT("");

FINDREPLACE findDlg; //     ""
UINT uFindMsgString = 0; //   FINDMSGSTRING

HFONT hFont = NULL; //  

//    
LRESULT CALLBACK MyWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

// ,      ,
//     
void OnIdle(HWND hwnd);
// ,      
//  ,       
BOOL PreTranslateMessage(LPMSG lpMsg);

//      :
//   WM_CREATE
BOOL OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct);
//   WM_DESTROY
void OnDestroy(HWND hwnd);
//   WM_SIZE
void OnSize(HWND hwnd, UINT state, int cx, int cy);
//   WM_COMMAND
void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
//   WM_ADDITEM
void OnAddItem(HWND hwnd);
//   FindMsgString
void OnFindMsgString(HWND hwnd, LPFINDREPLACE lpFindReplace);

//   
INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

//      :
//   WM_INITDIALOG
BOOL Dialog_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam);
//   WM_CLOSE
void Dialog_OnClose(HWND hwnd);
//   WM_COMMAND
void Dialog_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);

// ------------------------------------------------------------------------------------------------
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE, LPTSTR lpszCmdLine, int nCmdShow)
{
    //     ...

    WNDCLASSEX wcex = { sizeof(WNDCLASSEX) };
    wcex.style = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
    wcex.lpfnWndProc = MyWindowProc; //  
    wcex.hInstance = hInstance;
    wcex.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
    wcex.lpszMenuName = MAKEINTRESOURCE(IDR_MENU1);
    wcex.lpszClassName = TEXT("MyWindowClass"); //  
    wcex.hIconSm = LoadIcon(NULL, IDI_APPLICATION);

    if (0 == RegisterClassEx(&wcex)) //  
    {
        //      
        return -1; //   
    } // if

    //  
    //    
    LoadLibrary(TEXT("ComCtl32.dll"));

    //    
    hAccel = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDR_ACCELERATOR1));

    //        
    hWnd = CreateWindowEx(0, TEXT("MyWindowClass"), TEXT("SampleWin32"), WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

    if (NULL == hWnd) //     
    {
        return -1; //   
    } // if

    ShowWindow(hWnd, nCmdShow); //   

    //     ...

    MSG  msg;
    BOOL bRet;

    for (;;)
    {
        //     
        while (!PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
        {
            OnIdle(hWnd);
        } // while

        //    
        bRet = GetMessage(&msg, NULL, 0, 0);

        if (bRet == -1)
        {
            /*        */
        } // if
        else if (FALSE == bRet)
        {
            break; //  WM_QUIT,   
        } // if
        else if (!PreTranslateMessage(&msg))
        {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        } // if
    } // for

    return (int)msg.wParam; //   
} // _tWinMain

// ------------------------------------------------------------------------------------------------
LRESULT CALLBACK MyWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hWnd, WM_CREATE, OnCreate);
        HANDLE_MSG(hWnd, WM_DESTROY, OnDestroy);
        HANDLE_MSG(hWnd, WM_SIZE, OnSize);
        HANDLE_MSG(hWnd, WM_COMMAND, OnCommand);
    case WM_ADDITEM:
        OnAddItem(hWnd);
        return 0;
    } // switch

    if (uFindMsgString == uMsg) //  FINDMSGSTRING
    {
        OnFindMsgString(hWnd, (LPFINDREPLACE)lParam);
        return 0;
    } // if

    //   
    //    
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
} // MyWindowProc

// ------------------------------------------------------------------------------------------------
void OnIdle(HWND hwnd)
{
    /*     -  */
} // OnIdle

// ------------------------------------------------------------------------------------------------
BOOL PreTranslateMessage(LPMSG lpMsg)
{
    BOOL bRet = TRUE;

    if (!TranslateAccelerator(hWnd, hAccel, lpMsg))
    {
        bRet = IsDialogMessage(hDlg, lpMsg);

        if (FALSE == bRet)
            bRet = IsDialogMessage(hFindDlg, lpMsg);
    } // if

    return bRet;
} // PreTranslateMessage

// ------------------------------------------------------------------------------------------------
BOOL OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct)
{
    //  
    CreateWindowEx(0, TEXT("ListBox"), NULL,
        WS_CHILD|WS_VISIBLE|WS_BORDER|LBS_STANDARD, 10, 10, 250, 410, hwnd, (HMENU)IDC_LIST, lpCreateStruct->hInstance, NULL);

    //   " "
    CreateWindowEx(0, TEXT("Button"), TEXT(" "),
        WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 270, 10, 200, 40, hwnd, (HMENU)ID_NEW_RECORD, lpCreateStruct->hInstance, NULL);

    //   " . "
    CreateWindowEx(0, TEXT("Button"), TEXT(" . "),
        WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 270, 55, 200, 40, hwnd, (HMENU)ID_NEW_RECORD2, lpCreateStruct->hInstance, NULL);

    //   " "
    CreateWindowEx(0, TEXT("Button"), TEXT(" "),
        WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 270, 100, 200, 40, hwnd, (HMENU)ID_DEL_RECORD, lpCreateStruct->hInstance, NULL);

    //   " "
    CreateWindowEx(0, TEXT("Button"), TEXT(" "),
        WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 270, 145, 200, 40, hwnd, (HMENU)ID_FIND_RECORD, lpCreateStruct->hInstance, NULL);

    //   " "
    CreateWindowEx(0, TEXT("Button"), TEXT(" "),
        WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 270, 210, 200, 40, hwnd, (HMENU)ID_FORMAT_FONT, lpCreateStruct->hInstance, NULL);

    return TRUE;
} // OnCreate

// ------------------------------------------------------------------------------------------------
void OnDestroy(HWND hwnd)
{
    //   
    if (NULL != hFont)
        DeleteObject(hFont), hFont = NULL;

    PostQuitMessage(0); //   WM_QUIT
} // OnDestroy

// ------------------------------------------------------------------------------------------------
void OnSize(HWND hwnd, UINT state, int cx, int cy)
{
    if (state != SIZE_MINIMIZED)
    {
        //   
        HWND hwndCtl = GetDlgItem(hwnd, IDC_LIST);
        //   
        MoveWindow(hwndCtl, 10, 10, 250, cy-20, TRUE);
    } // if
} // OnSize

// ------------------------------------------------------------------------------------------------
void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    //    
    HINSTANCE hInstance = GetWindowInstance(hwnd);

    switch (id)
    {
    case ID_NEW_RECORD: //   " "
        {
            //    
            int nDlgResult = DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), hwnd, DialogProc);

            if (IDOK == nDlgResult)
            {
                //     ,    
                SendMessage(hwnd, WM_ADDITEM, 0 ,0);
            } // if
        }
        break;

    case ID_NEW_RECORD2: //   " . "
        //       
        if (IsWindow(hDlg) == FALSE)
        {
            //    
            hDlg = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), hwnd, DialogProc);
            //    
            ShowWindow(hDlg, SW_SHOW);
        } // if
        break;

    case ID_DEL_RECORD: //   " "
        {
            //   
            HWND hwndCtl = GetDlgItem(hwnd, IDC_LIST);

            //      
            int iItem = ListBox_GetCurSel(hwndCtl);

            if (iItem != -1)
            {
                int mbResult = MessageBox(hwnd, TEXT("  ?"), TEXT("SampleWin32"), MB_YESNO|MB_ICONQUESTION);

                if (mbResult == IDYES)
                {
                    //     
                    ListBox_DeleteString(hwndCtl, iItem);
                } // if
            } // if
        }
        break;

    case ID_FIND_RECORD: //   " "
        if (0 == uFindMsgString)
        {
            //    FINDMSGSTRING
            uFindMsgString = RegisterWindowMessage(FINDMSGSTRING);
        } // if

        //    ""   
        if (IsWindow(hFindDlg) == FALSE)
        {
            findDlg.lStructSize = sizeof(FINDREPLACE);

            //    
            findDlg.hInstance = hInstance;
            //    
            findDlg.hwndOwner = hwnd;

            //   
            findDlg.lpstrFindWhat = szBuffer;
            //   
            findDlg.wFindWhatLen = _countof(szBuffer);

            //    ""
            hFindDlg = FindText(&findDlg);
        } // if
        break;

    case ID_FORMAT_FONT: //   " "
        {
            CHOOSEFONT cf = { sizeof(CHOOSEFONT) };

            //    
            cf.hInstance = hInstance;
            //    
            cf.hwndOwner = hwnd;

            LOGFONT lf;
            ZeroMemory(&lf, sizeof(lf));

            cf.lpLogFont = &lf; //  ,      

            BOOL bRet = ChooseFont(&cf);

            if (FALSE != bRet)
            {
                //   
                HFONT hNewFont = CreateFontIndirect(cf.lpLogFont);

                if (NULL != hNewFont)
                {
                    //    
                    if (NULL != hFont) DeleteObject(hFont);
                    //     
                    hFont = hNewFont;
                    SendDlgItemMessage(hwnd, IDC_LIST, WM_SETFONT, (WPARAM)hFont, (LPARAM)TRUE);
                } // if
            } // if
        }
        break;
    } // switch
} // OnCommand

// ------------------------------------------------------------------------------------------------
void OnAddItem(HWND hwnd)
{
    //   
    HWND hwndCtl = GetDlgItem(hwnd, IDC_LIST);

    //     
    int iItem = ListBox_AddString(hwndCtl, szBuffer);

    //   
    ListBox_SetCurSel(hwndCtl, iItem);
} // OnAddItem

// ------------------------------------------------------------------------------------------------
void OnFindMsgString(HWND hwnd, LPFINDREPLACE lpFindReplace)
{
    if (lpFindReplace->Flags & FR_FINDNEXT) //   " "
    {
        //   
        HWND hwndCtl = GetDlgItem(hwnd, IDC_LIST);

        //      
        int iItem = ListBox_GetCurSel(hwndCtl);

        //      
        //     
        iItem = ListBox_FindString(hwndCtl, iItem, lpFindReplace->lpstrFindWhat);

        //   
        ListBox_SetCurSel(hwndCtl, iItem);

        if (LB_ERR == iItem) //   
        {
            MessageBox(hFindDlg, TEXT(" "), TEXT("SampleWin32"), MB_OK|MB_ICONINFORMATION);
        } // if
    } // if
} // OnFindMsgString

// ------------------------------------------------------------------------------------------------
INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
    case WM_INITDIALOG:
        {
            BOOL bRet = HANDLE_WM_INITDIALOG(hwndDlg, wParam, lParam, Dialog_OnInitDialog);
            return SetDlgMsgResult(hwndDlg, uMsg, bRet);
        }
    case WM_CLOSE:
        HANDLE_WM_CLOSE(hwndDlg, wParam, lParam, Dialog_OnClose);
        return TRUE;
    case WM_COMMAND:
        HANDLE_WM_COMMAND(hwndDlg, wParam, lParam, Dialog_OnCommand);
        return TRUE;
    } // switch

    return FALSE;
} // DialogProc

// ------------------------------------------------------------------------------------------------
BOOL Dialog_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    //     
    HWND hwndEdit = GetDlgItem(hwnd, IDC_EDIT1);

    //       
    Edit_LimitText(hwndEdit, _countof(szBuffer)-1);

    //   ()    
    Edit_SetCueBannerText(hwndEdit, L"  ");

    return TRUE;
} // Dialog_OnInitDialog

// ------------------------------------------------------------------------------------------------
void Dialog_OnClose(HWND hwnd)
{
    if (hwnd == hDlg)
    {
        //    
        DestroyWindow(hwnd);
    } // if
    else
    {
        //     
        EndDialog(hwnd, IDCLOSE);
    } // else
} // Dialog_OnClose

// ------------------------------------------------------------------------------------------------
void Dialog_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDOK: //   ""
        {
            //    
            int cch = GetDlgItemText(hwnd, IDC_EDIT1, szBuffer, _countof(szBuffer));

            if (0 == cch) //     
            {
                //     
                HWND hwndEdit = GetDlgItem(hwnd, IDC_EDIT1);

                EDITBALLOONTIP ebt = { sizeof(EDITBALLOONTIP) };

                ebt.pszTitle = L"SampleWin32";
                ebt.pszText = L"   ";
                ebt.ttiIcon = TTI_WARNING;

                Edit_ShowBalloonTip(hwndEdit, &ebt);
            } // if
            else if (hwnd == hDlg)
            {
                //   
                SetDlgItemText(hwnd, IDC_EDIT1, NULL);
                //  -   ,    
                SendMessage(GetParent(hwnd), WM_ADDITEM, 0, 0);
            } // if
            else
            {
                //     
                EndDialog(hwnd, IDOK);
            } // else
        } // if
        break;

    case IDCANCEL: //   ""
        if (hwnd == hDlg)
        {
            //    
            DestroyWindow(hwnd);
        } // if
        else
        {
            //     
            EndDialog(hwnd, IDCANCEL);
        } // else
        break;
    } // switch
} // Dialog_OnCommand
