// Sample (listview).cpp
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#include <Windows.h>
#include <WindowsX.h>
#include <CommCtrl.h>
#include <tchar.h>
#include <strsafe.h>

#include "resource.h"
#include "afxres.h"

//      
#define IDC_LIST             2001
#define IDC_MONTHCAL         2002

//    WM_ADDITEM,
//      
#define WM_ADDITEM           WM_USER + 1

HWND hWnd = NULL; //   

HACCEL hAccel = NULL; //    

//    
HWND hDlg = NULL;
HWND hFindDlg = NULL;

TCHAR szBuffer[100] = TEXT("");
TCHAR szBuffer2[100] = TEXT("");

SYSTEMTIME st;

FINDREPLACE findDlg; //     ""
UINT uFindMsgString = 0; //   FINDMSGSTRING

//    
LRESULT CALLBACK MyWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

// ,      
//  ,       
BOOL PreTranslateMessage(LPMSG lpMsg);

//      :
//   WM_CREATE
BOOL OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct);
//   WM_DESTROY
void OnDestroy(HWND hwnd);
//   WM_SIZE
void OnSize(HWND hwnd, UINT state, int cx, int cy);
//   WM_COMMAND
void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
//   WM_ADDITEM
void OnAddItem(HWND hwnd);
//   FindMsgString
void OnFindMsgString(HWND hwnd, LPFINDREPLACE lpFindReplace);
//   WM_NOTIFY
void OnNotify(HWND hwnd, LPNMHDR lpnmhdr);
//   WM_SIZING
void OnSizing(HWND hwnd, LPRECT lpRect);
//   WM_KEYDOWN
void OnKeyDown(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags);
//   WM_CHAR
void OnChar(HWND hwnd, TCHAR ch, int cRepeat);
//   WM_MOVE
void OnMove(HWND hwnd, int x, int y);

//   
INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

//      :
//   WM_INITDIALOG
BOOL Dialog_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam);
//   WM_CLOSE
void Dialog_OnClose(HWND hwnd);
//   WM_COMMAND
void Dialog_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);

// ------------------------------------------------------------------------------------------------
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE, LPTSTR lpszCmdLine, int nCmdShow)
{
    //     ...

    WNDCLASSEX wcex = { sizeof(WNDCLASSEX) };
    wcex.style = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
    wcex.lpfnWndProc = MyWindowProc; //  
    wcex.hInstance = hInstance;
    wcex.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
    wcex.lpszMenuName = MAKEINTRESOURCE(IDR_MENU1);
    wcex.lpszClassName = TEXT("MyWindowClass"); //  
    wcex.hIconSm = LoadIcon(NULL, IDI_APPLICATION);

    if (0 == RegisterClassEx(&wcex)) //  
    {
        //      
        return -1; //   
    } // if

    //  
    //    
    LoadLibrary(TEXT("ComCtl32.dll"));

    //    
    hAccel = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDR_ACCELERATOR1));

    //        
    hWnd = CreateWindowEx(0, TEXT("MyWindowClass"), TEXT("SampleWin32"), WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

    if (NULL == hWnd) //     
    {
        return -1; //   
    } // if

    ShowWindow(hWnd, nCmdShow); //   

    //     ...

    MSG  msg;
    BOOL bRet;

    while ((bRet = GetMessage(&msg, NULL, 0, 0)) != FALSE)
    {
        if (bRet == -1)
        {
            /*        */
        } // if
        else if (!PreTranslateMessage(&msg))
        {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        } // if
    } // while

    return (int)msg.wParam; //   
} // _tWinMain

// ------------------------------------------------------------------------------------------------
LRESULT CALLBACK MyWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hWnd, WM_CREATE, OnCreate);
        HANDLE_MSG(hWnd, WM_DESTROY, OnDestroy);
        HANDLE_MSG(hWnd, WM_SIZE, OnSize);
        HANDLE_MSG(hWnd, WM_COMMAND, OnCommand);
        HANDLE_MSG(hWnd, WM_KEYDOWN, OnKeyDown);
        HANDLE_MSG(hWnd, WM_CHAR, OnChar);
        HANDLE_MSG(hWnd, WM_MOVE, OnMove);
    case WM_ADDITEM:
        OnAddItem(hWnd);
        return 0;
    case WM_NOTIFY:
        OnNotify(hWnd, (LPNMHDR)lParam);
        return 0;
    case WM_SIZING:
        OnSizing(hWnd, (LPRECT)lParam);
        return 0;
    } // switch

    if (uFindMsgString == uMsg) //  FINDMSGSTRING
    {
        OnFindMsgString(hWnd, (LPFINDREPLACE)lParam);
        return 0;
    } // if

    //   
    //    
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
} // MyWindowProc

// ------------------------------------------------------------------------------------------------
BOOL PreTranslateMessage(LPMSG lpMsg)
{
    BOOL bRet = TRUE;

    if (!TranslateAccelerator(hWnd, hAccel, lpMsg))
    {
        bRet = IsDialogMessage(hDlg, lpMsg);

        if (FALSE == bRet)
            bRet = IsDialogMessage(hFindDlg, lpMsg);
    } // if

    return bRet;
} // PreTranslateMessage

// ------------------------------------------------------------------------------------------------
BOOL OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct)
{
    //   
    HWND hwndLV = CreateWindowEx(0, TEXT("SysListView32"), NULL,
        WS_CHILD|WS_VISIBLE|WS_BORDER|LVS_REPORT|LVS_SHOWSELALWAYS|LVS_SORTASCENDING, 270, 10, 250, 410, hwnd, (HMENU)IDC_LIST, lpCreateStruct->hInstance, NULL);

    //   
    ListView_SetExtendedListViewStyle(hwndLV, LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);

    //      

    LVCOLUMN lvColumns[] = {
        { LVCF_WIDTH | LVCF_TEXT, 0, 300, (LPTSTR)TEXT("") },
        { LVCF_WIDTH | LVCF_TEXT, 0, 200, (LPTSTR)TEXT("") },
    };

    for (int i = 0; i < _countof(lvColumns); ++i)
    {
        //  
        ListView_InsertColumn(hwndLV, i, &lvColumns[i]);
    } // for

    //   " "
    CreateWindowEx(0, TEXT("Button"), TEXT(" "),
        WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 10, 10, 250, 40, hwnd, (HMENU)ID_NEW_RECORD, lpCreateStruct->hInstance, NULL);

    //   " . "
    CreateWindowEx(0, TEXT("Button"), TEXT(" . "),
        WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 10, 55, 250, 40, hwnd, (HMENU)ID_NEW_RECORD2, lpCreateStruct->hInstance, NULL);

    //   " "
    CreateWindowEx(0, TEXT("Button"), TEXT(" ()"),
        WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 10, 100, 250, 40, hwnd, (HMENU)ID_DEL_RECORD, lpCreateStruct->hInstance, NULL);

    //   " "
    CreateWindowEx(0, TEXT("Button"), TEXT("  "),
        WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 10, 145, 250, 40, hwnd, (HMENU)ID_FIND_RECORD, lpCreateStruct->hInstance, NULL);

    //   " "
    CreateWindowEx(0, TEXT("Button"), TEXT(""),
        WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 10, 190, 250, 40, hwnd, (HMENU)ID_FILE_PRINT, lpCreateStruct->hInstance, NULL);


    //  
    CreateWindowEx(0, TEXT("SysMonthCal32"), TEXT(""),
        WS_CHILD|WS_VISIBLE|WS_BORDER|MCS_NOTODAY, 10, 240, 250, 250, hwnd, (HMENU)IDC_MONTHCAL, lpCreateStruct->hInstance, NULL);

    CreateWindowEx(0, TEXT("Static"), TEXT("  ,            "),
        WS_CHILD|WS_VISIBLE|SS_CENTER, 10, 500, 250, 60, hwnd, (HMENU)IDC_STATIC, lpCreateStruct->hInstance, NULL);

    return TRUE;
} // OnCreate

// ------------------------------------------------------------------------------------------------
void OnDestroy(HWND hwnd)
{
    PostQuitMessage(0); //   WM_QUIT
} // OnDestroy

// ------------------------------------------------------------------------------------------------
void OnSize(HWND hwnd, UINT state, int cx, int cy)
{
    if (state != SIZE_MINIMIZED)
    {
        //   
        HWND hwndCtl = GetDlgItem(hwnd, IDC_LIST);
        //   
        MoveWindow(hwndCtl, 270, 10, cx-280, cy-20, TRUE);
    } // if
} // OnSize

// ------------------------------------------------------------------------------------------------
void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    //    
    HINSTANCE hInstance = GetWindowInstance(hwnd);

    switch (id)
    {
    case ID_FILE_OPEN: // ...
        {
            TCHAR szFileName[MAX_PATH] = TEXT(""); //  

            OPENFILENAME ofn = { sizeof(OPENFILENAME) };

            ofn.hInstance = GetWindowInstance(hwnd);
            ofn.lpstrFilter = TEXT("  (*.*)\0*.*\0 XML (*.xml)\0*.xml\0");
            ofn.lpstrFile = szFileName;
            ofn.nMaxFile = _countof(szFileName);
            ofn.lpstrTitle = TEXT("");
            ofn.Flags = OFN_EXPLORER | OFN_ENABLESIZING | OFN_FILEMUSTEXIST;
            ofn.lpstrDefExt = TEXT("xml");

            if (GetOpenFileName(&ofn) != FALSE)
            {
                MessageBox(hwnd, szFileName, TEXT(""), MB_OK | MB_ICONINFORMATION);
            } // if
        }
        break;

    case ID_FILE_SAVE_AS: //  ...
        {
            TCHAR szFileName[MAX_PATH] = TEXT(""); //  

            OPENFILENAME ofn = { sizeof(OPENFILENAME) };

            ofn.hInstance = GetWindowInstance(hwnd);
            ofn.lpstrFilter = TEXT("  (*.*)\0*.*\0 XML (*.xml)\0*.xml\0");
            ofn.lpstrFile = szFileName;
            ofn.nMaxFile = _countof(szFileName);
            ofn.lpstrTitle = TEXT(" ");
            ofn.Flags = OFN_EXPLORER | OFN_ENABLESIZING | OFN_CREATEPROMPT | OFN_OVERWRITEPROMPT;
            ofn.lpstrDefExt = TEXT("xml");

            if (GetSaveFileName(&ofn) != FALSE)
            {
                MessageBox(hwnd, szFileName, TEXT(" "), MB_OK | MB_ICONINFORMATION);
            } // if
        }
        break;

    case ID_FILE_PRINT: //  ...
        {
            PRINTDLG pd = { sizeof(PRINTDLG) };

            pd.Flags = PD_ALLPAGES|PD_USEDEVMODECOPIESANDCOLLATE; 
            pd.hwndOwner = hWnd; //  -
            pd.nCopies = 1; //  
            pd.nFromPage = 15; //  
            pd.nToPage = 48; //  
            pd.nMinPage = 1;  //    
            pd.nMaxPage = 65535; //    

            if (PrintDlg(&pd) != FALSE) 
            {
                TCHAR szText[100];
                StringCchPrintf(szText, _countof(szText), TEXT(" %d (,)"), (pd.nToPage - pd.nFromPage));

                MessageBox(hwnd, szText, TEXT(""), MB_OK | MB_ICONINFORMATION);
            } // if
        }
        break;

    case ID_NEW_RECORD: //   " "
        {
            //    
            int nDlgResult = DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), hwnd, DialogProc);

            if (IDOK == nDlgResult)
            {
                //     ,    
                SendMessage(hwnd, WM_ADDITEM, 0 ,0);
            } // if
        }
        break;

    case ID_NEW_RECORD2: //   " . "
        //       
        if (IsWindow(hDlg) == FALSE)
        {
            //    
            hDlg = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), hwnd, DialogProc);
            //    
            ShowWindow(hDlg, SW_SHOW);
        } // if
        break;

    case ID_DEL_RECORD: //   " ()"
        {
            //    
            HWND hwndLV = GetDlgItem(hwnd, IDC_LIST);

            //       
            int iItem = ListView_GetNextItem(hwndLV, -1, LVNI_SELECTED);

            if (iItem != -1)
            {
                int mbResult = MessageBox(hwnd, TEXT("  ?"), TEXT("SampleWin32"), MB_YESNO|MB_ICONQUESTION);

                if (mbResult == IDYES)
                {
                    do
                    {
                        //     
                        ListView_DeleteItem(hwndLV, iItem);
                        //       
                        iItem = ListView_GetNextItem(hwndLV, iItem - 1, LVNI_SELECTED);
                    } while (iItem != -1);
                } // if
            } // if
        }
        break;

    case ID_FIND_RECORD: //   "  "
        if (0 == uFindMsgString)
        {
            //    FINDMSGSTRING
            uFindMsgString = RegisterWindowMessage(FINDMSGSTRING);
        } // if

        //    ""   
        if (IsWindow(hFindDlg) == FALSE)
        {
            findDlg.lStructSize = sizeof(FINDREPLACE);

            findDlg.Flags = FR_HIDEUPDOWN | FR_HIDEWHOLEWORD | FR_HIDEMATCHCASE;

            //    
            findDlg.hInstance = hInstance;
            //    
            findDlg.hwndOwner = hwnd;

            //   
            findDlg.lpstrFindWhat = szBuffer;
            //   
            findDlg.wFindWhatLen = _countof(szBuffer);

            //   
            findDlg.lpstrReplaceWith = szBuffer2;
            //   
            findDlg.wReplaceWithLen = _countof(szBuffer2);

            //    ""
            hFindDlg = ReplaceText(&findDlg);
        } // if
        break;
    } // switch
} // OnCommand

// ------------------------------------------------------------------------------------------------
void OnAddItem(HWND hwnd)
{
    //    
    HWND hwndLV = GetDlgItem(hwnd, IDC_LIST);

    //      

    LVITEM lvItem = { LVIF_TEXT | LVIF_PARAM };

    lvItem.iItem = ListView_GetItemCount(hwndLV);
    lvItem.pszText = szBuffer;

    //      
    lvItem.iItem = ListView_InsertItem(hwndLV, &lvItem);

    if ((lvItem.iItem != -1) && (st.wYear != 0))
    {
        TCHAR szText[100];
        GetDateFormat(LOCALE_USER_DEFAULT, DATE_LONGDATE, &st, NULL, szText, _countof(szText));

        //     
        ListView_SetItemText(hwndLV, lvItem.iItem, 1, szText);
    } // if
} // OnAddItem

// ------------------------------------------------------------------------------------------------
void OnFindMsgString(HWND hwnd, LPFINDREPLACE lpFindReplace)
{
    //    
    HWND hwndLV = GetDlgItem(hwnd, IDC_LIST);

    if (lpFindReplace->Flags & FR_REPLACE) //   ""
    {
        LVFINDINFO fi = { LVFI_STRING };
        fi.psz = szBuffer;

        //         
        int iItem = ListView_FindItem(hwndLV, -1, &fi);

        if (iItem != -1)
        {
            //       
            ListView_SetItemText(hwndLV, iItem, 0, szBuffer2);
        } // if
        else
        {
            MessageBox(hFindDlg, TEXT(" "), TEXT("SampleWin32"), MB_OK | MB_ICONINFORMATION);
        } // else
    } // if
    else if (lpFindReplace->Flags & FR_REPLACEALL) //   " "
    {
        LVFINDINFO fi = { LVFI_STRING };
        fi.psz = szBuffer;

        int iItem = -1;

        for (;;)
        {
            //         
            iItem = ListView_FindItem(hwndLV, iItem, &fi);

            if (iItem != -1)
            {
                //       
                ListView_SetItemText(hwndLV, iItem, 0, szBuffer2);
            } // if
            else
            {
                break; //   
            } // else
        } // for
    } // if
} // OnFindMsgString

// ------------------------------------------------------------------------------------------------
void OnNotify(HWND hwnd, LPNMHDR lpnmhdr)
{
    switch (lpnmhdr->code)
    {
    case NM_DBLCLK: //     
        if (lpnmhdr->idFrom == IDC_LIST)
        {
            LPNMITEMACTIVATE lpnmitem = (LPNMITEMACTIVATE)lpnmhdr;

            if ((lpnmitem->iItem != -1) && (1 == lpnmitem->iSubItem))  //   
            {
                //    
                MonthCal_GetCurSel(GetDlgItem(hwnd, IDC_MONTHCAL), &st);

                TCHAR szText[100];
                GetDateFormat(LOCALE_USER_DEFAULT, DATE_LONGDATE, &st, NULL, szText, _countof(szText));

                //     
                ListView_SetItemText(lpnmhdr->hwndFrom, lpnmitem->iItem, 1, szText);
            } // if
        } // if
        break;
    } // switch
} // OnNotify

// ------------------------------------------------------------------------------------------------
void OnSizing(HWND hwnd, LPRECT lpRect)
{
    //   
    int width = (lpRect->right - lpRect->left);
    //   
    int height = (lpRect->bottom - lpRect->top);

    if (width < 900) //   = 900 px
    {
        //     
        lpRect->right = lpRect->left + 900;
    } // if

    if (height < 700) //   = 700 px
    {
        //     
        lpRect->bottom = lpRect->top + 700;
    } // if
} // OnSizing

// ------------------------------------------------------------------------------------------------
void OnKeyDown(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
{
    if (VK_ESCAPE == vk) //   Esc
    {
        DestroyWindow(hwnd); //  
    } // if
} // OnKeyDown

// ------------------------------------------------------------------------------------------------
void OnChar(HWND hwnd, TCHAR ch, int cRepeat)
{
    //   ,    ch

    //    
    HWND hwndLV = GetDlgItem(hwnd, IDC_LIST);

    //      
    int nCount = ListView_GetItemCount(hwndLV);

    for (int iItem = 0; iItem < nCount; ++iItem)
    {
        TCHAR str[2] = TEXT("");
        //   
        ListView_GetItemText(hwndLV, iItem, 0, str, _countof(str));

        HRESULT hr = CompareString(LOCALE_USER_DEFAULT, NORM_IGNORECASE, &ch, 1, str, 1);

        if (CSTR_EQUAL == hr)
        {
            //    ( )
            ListView_SetItemState(hwndLV, iItem, LVNI_SELECTED, LVNI_SELECTED);
        } // if
        else
        {
            //    ( )
            ListView_SetItemState(hwndLV, iItem, 0, LVNI_SELECTED);
        } // else
    } // for
} // OnChar

// ------------------------------------------------------------------------------------------------
void OnMove(HWND hwnd, int x, int y)
{
    if (NULL != hDlg)
    {
        //   
        SetWindowPos(hDlg, NULL, x, y, 0, 0, SWP_NOSIZE);
    } // if
} // OnMove

// ------------------------------------------------------------------------------------------------
INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
    case WM_INITDIALOG:
        {
            BOOL bRet = HANDLE_WM_INITDIALOG(hwndDlg, wParam, lParam, Dialog_OnInitDialog);
            return SetDlgMsgResult(hwndDlg, uMsg, bRet);
        }
    case WM_CLOSE:
        HANDLE_WM_CLOSE(hwndDlg, wParam, lParam, Dialog_OnClose);
        return TRUE;
    case WM_COMMAND:
        HANDLE_WM_COMMAND(hwndDlg, wParam, lParam, Dialog_OnCommand);
        return TRUE;
    } // switch

    return FALSE;
} // DialogProc

// ------------------------------------------------------------------------------------------------
BOOL Dialog_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    //     
    HWND hwndCtrl = GetDlgItem(hwnd, IDC_COMBO1);

    //       
    ComboBox_LimitText(hwndCtrl, _countof(szBuffer) - 1);

    //   ()    
    ComboBox_SetCueBannerText(hwndCtrl, L"  ");

    return TRUE;
} // Dialog_OnInitDialog

// ------------------------------------------------------------------------------------------------
void Dialog_OnClose(HWND hwnd)
{
    if (hwnd == hDlg)
    {
        //    
        DestroyWindow(hwnd);
    } // if
    else
    {
        //     
        EndDialog(hwnd, IDCLOSE);
    } // else
} // Dialog_OnClose

// ------------------------------------------------------------------------------------------------
void Dialog_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDOK: //   ""
        {
            //     
            HWND hwndCtrl = GetDlgItem(hwnd, IDC_COMBO1);

            int cch;

            //       
            int index = ComboBox_GetCurSel(hwndCtrl);

            if (index != -1)
            {
                //   
                cch = ComboBox_GetLBText(hwndCtrl, index, szBuffer);
            } // if
            else
            {
                //    
                cch = ComboBox_GetText(hwndCtrl, szBuffer, _countof(szBuffer));
            } // else

            if (0 == cch) //     
            {
                //   
                ComboBox_ShowDropdown(hwndCtrl, TRUE);
            } // if
            else
            {
                ZeroMemory(&st, sizeof(st));
                //     
                SendDlgItemMessage(hwnd, IDC_DATETIMEPICKER1, DTM_GETSYSTEMTIME, 0, (LPARAM)&st);

                if (index == -1)
                {
                    //     
                    ComboBox_InsertString(hwndCtrl, -1, szBuffer);
                } // if

                if(hwnd == hDlg)
                {
                    //   
                    ComboBox_SetText(hwndCtrl, NULL);
                    //  -   ,    
                    SendMessage(GetParent(hwnd), WM_ADDITEM, 0, 0);
                } // if
                else
                {
                    //     
                    EndDialog(hwnd, IDOK);
                } // else
            } // else
        } // if
        break;

    case IDCANCEL: //   ""
        if (hwnd == hDlg)
        {
            //    
            DestroyWindow(hwnd);
        } // if
        else
        {
            //     
            EndDialog(hwnd, IDCANCEL);
        } // else
        break;
    } // switch
} // Dialog_OnCommand
