// Sample (tabs).cpp
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#pragma comment(lib, "comctl32.lib")

#include <Windows.h>
#include <WindowsX.h>
#include <CommCtrl.h>
#include <tchar.h>

#include "afxres.h"

//      
#define IDC_TABS            2001
#define IDC_IPADDR          2002
#define IDC_NETMASK         2003
#define IDC_MAKENETMASK     2004
#define IDC_EDIT_SEC        2005
#define IDC_UPDOWN          2006
#define IDC_TIMER           2007
#define IDC_PROGRESS        2008
#define IDC_GROUP           2009
#define IDC_RADIO_MINUTES   2010
#define IDC_RADIO_SECONDS   2011
#define IDC_RADIO_MSECONDS  2012
#define IDC_SLIDER          2013

//  
#define ID_TIMER            1

#define WIDTH               550
#define HEIGHT              300

HWND hWnd = NULL; //   
DWORD dwTimer = 0; //  

RECT rect; //    ,
    //  ""  

//    
LRESULT CALLBACK MyWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

//      :
//   WM_CREATE
BOOL OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct);
//   WM_DESTROY
void OnDestroy(HWND hwnd);
//   WM_SIZE
void OnSize(HWND hwnd, UINT state, int cx, int cy);
//   WM_COMMAND
void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
//   WM_NOTIFY
void OnNotify(HWND hwnd, LPNMHDR lpnmhdr);
//   WM_TIMER
void OnTimer(HWND hwnd, UINT id);
//   WM_VSCROLL
void OnVScroll(HWND hwnd, HWND hwndCtl, UINT code, int pos);
//   WM_MOVING
void OnMoving(HWND hwnd, LPRECT lpRect);

// ------------------------------------------------------------------------------------------------
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE, LPTSTR lpszCmdLine, int nCmdShow)
{
    //     ...

    WNDCLASSEX wcex = { sizeof(WNDCLASSEX) };
    wcex.style = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
    wcex.lpfnWndProc = MyWindowProc; //  
    wcex.hInstance = hInstance;
    wcex.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
    wcex.lpszClassName = TEXT("MyWindowClass"); //  
    wcex.hIconSm = LoadIcon(NULL, IDI_APPLICATION);

    if (0 == RegisterClassEx(&wcex)) //  
    {
        //      
        return -1; //   
    } // if

    //  
    //    
    LoadLibrary(TEXT("ComCtl32.dll"));

    //        
    hWnd = CreateWindowEx(0, TEXT("MyWindowClass"), TEXT("SampleWin32"),
        WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX, CW_USEDEFAULT, 0, WIDTH, HEIGHT, NULL, NULL, hInstance, NULL);

    if (NULL == hWnd) //     
    {
        return -1; //   
    } // if

    //    
    GetWindowRect(hWnd, &rect);

    ShowWindow(hWnd, nCmdShow); //   

    //     ...

    MSG  msg;
    BOOL bRet;

    while ((bRet = GetMessage(&msg, NULL, 0, 0)) != FALSE)
    {
        if (bRet == -1)
        {
            /*        */
        } // if
        else
        {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        } // else
    } // while

    return (int)msg.wParam; //   
} // _tWinMain

// ------------------------------------------------------------------------------------------------
LRESULT CALLBACK MyWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hWnd, WM_CREATE, OnCreate);
        HANDLE_MSG(hWnd, WM_DESTROY, OnDestroy);
        HANDLE_MSG(hWnd, WM_SIZE, OnSize);
        HANDLE_MSG(hWnd, WM_COMMAND, OnCommand);
        HANDLE_MSG(hWnd, WM_TIMER, OnTimer);
        HANDLE_MSG(hWnd, WM_VSCROLL, OnVScroll);
    case WM_NOTIFY:
        OnNotify(hWnd, (LPNMHDR)lParam);
        return 0;
    case WM_MOVING:
        OnMoving(hWnd, (LPRECT)lParam);
        return 0;
    } // switch

    //   
    //    
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
} // MyWindowProc

// ------------------------------------------------------------------------------------------------
BOOL OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct)
{
    //    
    HWND hwndCtrl = CreateWindowEx(0, TEXT("SysTabControl32"), NULL, WS_CHILD|WS_VISIBLE|TCS_TABS,
        10, 10, 400, 400, hwnd, (HMENU)IDC_TABS, lpCreateStruct->hInstance, NULL);

    //  

    TCITEM tcItems[] = {
        { TCIF_TEXT, 0, 0, (LPTSTR)TEXT("IP-") },
        { TCIF_TEXT, 0, 0, (LPTSTR)TEXT("") },
    };

    for (int i = 0; i < _countof(tcItems); ++i)
    {
        TabCtrl_InsertItem(hwndCtrl, i, &tcItems[i]);
    } // for


    //    IP-
    CreateWindowEx(0, TEXT("SysIPAddress32"), NULL, WS_CHILD|WS_VISIBLE,
        50 + 20, 50, 150, 25, hwnd, (HMENU)IDC_IPADDR, lpCreateStruct->hInstance, NULL);

    //     
    CreateWindowEx(0, TEXT("SysIPAddress32"), NULL, WS_CHILD|WS_VISIBLE,
        50 + 20, 80, 150, 25, hwnd, (HMENU)IDC_NETMASK, lpCreateStruct->hInstance, NULL);

    //   " "
    CreateWindowEx(0, TEXT("Button"), TEXT(" "),
        WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 50 + 175, 78, 140, 28, hwnd, (HMENU)IDC_MAKENETMASK, lpCreateStruct->hInstance, NULL);


    //    
    hwndCtrl = CreateWindowEx(WS_EX_CLIENTEDGE, TEXT("Edit"), TEXT("10"), WS_CHILD|ES_NUMBER|ES_CENTER,
        50 + 20, 50, 100, 25, hwnd, (HMENU)IDC_EDIT_SEC, lpCreateStruct->hInstance, NULL);

    //      
    CreateUpDownControl(WS_CHILD|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_SETBUDDYINT,
        0, 0, 0, 0, hwnd, IDC_UPDOWN, lpCreateStruct->hInstance, hwndCtrl, 60, 1, 10);

    //   " "
    CreateWindowEx(0, TEXT("Button"), TEXT(" "),
        WS_CHILD|BS_PUSHBUTTON, 50 + 110, 48, 160, 28, hwnd, (HMENU)IDC_TIMER, lpCreateStruct->hInstance, NULL);

    //    
    CreateWindowEx(0, TEXT("msctls_progress32"), NULL,
        WS_CHILD|PBS_SMOOTH, 50 + 20, 100, 400, 28, hwnd, (HMENU)IDC_PROGRESS, lpCreateStruct->hInstance, NULL);

    //   
    CreateWindowEx(0, TEXT("Button"), TEXT(" "),
        WS_CHILD|BS_GROUPBOX, 50 + 20, 140, 250, 100, hwnd, (HMENU)IDC_GROUP, lpCreateStruct->hInstance, NULL);

    //   

    CreateWindowEx(0, TEXT("Button"), TEXT("1 "),
        WS_CHILD | BS_AUTORADIOBUTTON, 50 + 30, 160, 110, 25, hwnd, (HMENU)IDC_RADIO_MINUTES, lpCreateStruct->hInstance, NULL);

    CreateWindowEx(0, TEXT("Button"), TEXT("1 "),
        WS_CHILD|BS_AUTORADIOBUTTON, 50 + 30, 185, 110, 25, hwnd, (HMENU)IDC_RADIO_SECONDS, lpCreateStruct->hInstance, NULL);

    CreateWindowEx(0, TEXT("Button"), TEXT("1/10 "),
        WS_CHILD | BS_AUTORADIOBUTTON, 50 + 30, 210, 110, 25, hwnd, (HMENU)IDC_RADIO_MSECONDS, lpCreateStruct->hInstance, NULL);

    CheckRadioButton(hwnd, IDC_RADIO_MINUTES, IDC_RADIO_MSECONDS, IDC_RADIO_MINUTES);


    //      
    hwndCtrl = CreateWindowEx(0, TEXT("msctls_trackbar32"), NULL,
        WS_CHILD|WS_VISIBLE|TBS_BOTH|TBS_VERT|TBS_AUTOTICKS, 10, 10, 30, 110, hwnd, (HMENU)IDC_SLIDER, lpCreateStruct->hInstance, NULL);

    //    
    SendMessage(hwndCtrl, TBM_SETRANGE, (WPARAM)TRUE, (LPARAM)MAKELONG(0, 10));
    //    
    //SendMessage(hwndCtrl, TBM_SETPAGESIZE, 0, (LPARAM)100);
    //    
    SendMessage(hwndCtrl, TBM_SETPOS, (WPARAM)TRUE, (LPARAM)0);

    return TRUE;
} // OnCreate

// ------------------------------------------------------------------------------------------------
void OnDestroy(HWND hwnd)
{
    PostQuitMessage(0); //   WM_QUIT
} // OnDestroy

// ------------------------------------------------------------------------------------------------
void OnSize(HWND hwnd, UINT state, int cx, int cy)
{
    if (state != SIZE_MINIMIZED)
    {
        //     
        HWND hwndCtl = GetDlgItem(hwnd, IDC_TABS);
        //     
        MoveWindow(hwndCtl, 50 + 10, 10, cx-20-50, cy-20, TRUE);

        //     
        MoveWindow(GetDlgItem(hwnd, IDC_PROGRESS), 50 + 20, 100, cx-40-50, 28, TRUE);

        //      
        MoveWindow(GetDlgItem(hwnd, IDC_SLIDER), 10, 10, 30, cy - 20, TRUE);
    } // if
} // OnSize

// ------------------------------------------------------------------------------------------------
void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    //    
    HINSTANCE hInstance = GetWindowInstance(hwnd);

    switch (id)
    {
    case IDC_MAKENETMASK: //   " "
        {
            DWORD addr = 0; // IP-

            //  IP-   
            SendDlgItemMessage(hwnd, IDC_IPADDR, IPM_GETADDRESS, 0, (LPARAM)&addr);

            if (0 != addr)
            {
                if ((addr & 0x80000000) == 0x00000000) //  A
                {
                    //   255.0.0.0
                    SendDlgItemMessage(hwnd, IDC_NETMASK, IPM_SETADDRESS, 0, (LPARAM)0xFF000000);
                } // if
                else if ((addr & 0xC0000000) == 0x80000000) //  B
                {
                    //   255.255.0.0
                    SendDlgItemMessage(hwnd, IDC_NETMASK, IPM_SETADDRESS, 0, (LPARAM)0xFFFF0000);
                } // if
                else if ((addr & 0xE0000000) == 0xC0000000) //  C
                {
                    //   255.255.255.0
                    SendDlgItemMessage(hwnd, IDC_NETMASK, IPM_SETADDRESS, 0, (LPARAM)0xFFFFFF00);
                } // if
                else
                {
                    //    IP-
                    SendDlgItemMessage(hwnd, IDC_NETMASK, IPM_CLEARADDRESS, 0, 0);
                } // else
            } // if
            else
            {
                //    IP-
                SendDlgItemMessage(hwnd, IDC_NETMASK, IPM_CLEARADDRESS, 0, 0);
            } // else
        }
        break;

    case IDC_TIMER: //   " "
        {
            //      
            dwTimer = (DWORD)GetDlgItemInt(hwnd, IDC_EDIT_SEC, NULL, FALSE);

            if (dwTimer > 0)
            {
                //    

                EnableWindow(GetDlgItem(hwnd, IDC_EDIT_SEC), FALSE);
                EnableWindow(GetDlgItem(hwnd, IDC_UPDOWN), FALSE);
                EnableWindow(GetDlgItem(hwnd, IDC_TIMER), FALSE);
                EnableWindow(GetDlgItem(hwnd, IDC_RADIO_MSECONDS), FALSE);
                EnableWindow(GetDlgItem(hwnd, IDC_RADIO_SECONDS), FALSE);
                EnableWindow(GetDlgItem(hwnd, IDC_RADIO_MINUTES), FALSE);

                //      
                SendDlgItemMessage(hwnd, IDC_PROGRESS, PBM_SETRANGE32, (WPARAM)0, (LPARAM)dwTimer);
                //     
                SendDlgItemMessage(hwnd, IDC_PROGRESS, PBM_SETSTEP, (WPARAM)1, 0);
                //      
                SendDlgItemMessage(hwnd, IDC_PROGRESS, PBM_SETPOS, (WPARAM)0, 0);

                if (IsDlgButtonChecked(hwnd, IDC_RADIO_MSECONDS) == BST_CHECKED)
                {
                    //     1/10 
                    SetTimer(hwnd, ID_TIMER, 100, NULL);
                } // if
                else if (IsDlgButtonChecked(hwnd, IDC_RADIO_SECONDS) == BST_CHECKED)
                {
                    //     1 
                    SetTimer(hwnd, ID_TIMER, 1000, NULL);
                } // if
                else if (IsDlgButtonChecked(hwnd, IDC_RADIO_MINUTES) == BST_CHECKED)
                {
                    //     1 
                    SetTimer(hwnd, ID_TIMER, 60000, NULL);
                } // if
            } // if
        }
        break;
    } // switch
} // OnCommand

// ------------------------------------------------------------------------------------------------
void OnNotify(HWND hwnd, LPNMHDR lpnmhdr)
{
    switch (lpnmhdr->code)
    {
    case TCN_SELCHANGE:
        if (lpnmhdr->idFrom == IDC_TABS)
        {
            //    
            int index = TabCtrl_GetCurSel(lpnmhdr->hwndFrom);

            // /     

            int nShow = (0 == index) ? SW_SHOW : SW_HIDE;

            ShowWindow(GetDlgItem(hwnd, IDC_IPADDR), nShow);
            ShowWindow(GetDlgItem(hwnd, IDC_NETMASK), nShow);
            ShowWindow(GetDlgItem(hwnd, IDC_MAKENETMASK), nShow);

            nShow = (1 == index) ? SW_SHOW : SW_HIDE;

            ShowWindow(GetDlgItem(hwnd, IDC_EDIT_SEC), nShow);
            ShowWindow(GetDlgItem(hwnd, IDC_UPDOWN), nShow);
            ShowWindow(GetDlgItem(hwnd, IDC_TIMER), nShow);
            ShowWindow(GetDlgItem(hwnd, IDC_PROGRESS), nShow);
            ShowWindow(GetDlgItem(hwnd, IDC_GROUP), nShow);
            ShowWindow(GetDlgItem(hwnd, IDC_RADIO_MSECONDS), nShow);
            ShowWindow(GetDlgItem(hwnd, IDC_RADIO_SECONDS), nShow);
            ShowWindow(GetDlgItem(hwnd, IDC_RADIO_MINUTES), nShow);
        } // if
        break;
    } // switch
} // OnNotify

// ------------------------------------------------------------------------------------------------
void OnTimer(HWND hwnd, UINT id)
{
    if (ID_TIMER == id)
    {
        //   
        SendDlgItemMessage(hwnd, IDC_PROGRESS, PBM_STEPIT, 0, 0);

        if (0 == --dwTimer) //  
        {
            //  
            KillTimer(hwnd, ID_TIMER);

            //    

            EnableWindow(GetDlgItem(hwnd, IDC_EDIT_SEC), TRUE);
            EnableWindow(GetDlgItem(hwnd, IDC_UPDOWN), TRUE);
            EnableWindow(GetDlgItem(hwnd, IDC_TIMER), TRUE);
            EnableWindow(GetDlgItem(hwnd, IDC_RADIO_MSECONDS), TRUE);
            EnableWindow(GetDlgItem(hwnd, IDC_RADIO_SECONDS), TRUE);
            EnableWindow(GetDlgItem(hwnd, IDC_RADIO_MINUTES), TRUE);

            //      
            SendDlgItemMessage(hwnd, IDC_PROGRESS, PBM_SETPOS, (WPARAM)0, 0);
        } // if
    } // if
} // OnTimer

// ------------------------------------------------------------------------------------------------
void OnVScroll(HWND hwnd, HWND hwndCtl, UINT code, int pos)
{
    if (GetDlgItem(hwnd, IDC_SLIDER) == hwndCtl)
    {
        //     
        int dx = 100 * SendDlgItemMessage(hwnd, IDC_SLIDER, TBM_GETPOS, 0, 0);
        //   
        SetWindowPos(hwnd, NULL, 0, 0, WIDTH + dx, HEIGHT, SWP_NOMOVE);
    } // if
} // OnVScroll

// ------------------------------------------------------------------------------------------------
void OnMoving(HWND hwnd, LPRECT lpRect)
{
    //   
    int width = (lpRect->right - lpRect->left);
    //   
    int height = (lpRect->bottom - lpRect->top);

    /*  -      */

    lpRect->left = max(min(lpRect->left, rect.right), rect.left);
    lpRect->right = lpRect->left + width;

    lpRect->top = max(min(lpRect->top, rect.bottom), rect.top);
    lpRect->bottom = lpRect->top + height;
} // OnMoving
