// Sample (tree view).cpp
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#include <Windows.h>
#include <WindowsX.h>
#include <CommCtrl.h>
#include <tchar.h>

#include "resource.h"
#include "afxres.h"

//      
#define IDC_TREE             2001

//    WM_ADDITEM,
//      
#define WM_ADDITEM           WM_USER + 1

HWND hWnd = NULL; //   

HACCEL hAccel = NULL; //    

//    
HWND hDlg = NULL;
HWND hFindDlg = NULL;

TCHAR szBuffer[100] = TEXT("");
BOOL fInsertAddItemToRoot = TRUE; //  -      

FINDREPLACE findDlg; //     ""
UINT uFindMsgString = 0; //   FINDMSGSTRING

POINT ptDrag; //     (   )

//    
LRESULT CALLBACK MyWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

// ,      
//  ,       
BOOL PreTranslateMessage(LPMSG lpMsg);

//      :
//   WM_CREATE
BOOL OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct);
//   WM_DESTROY
void OnDestroy(HWND hwnd);
//   WM_SIZE
void OnSize(HWND hwnd, UINT state, int cx, int cy);
//   WM_COMMAND
void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
//   WM_ADDITEM
void OnAddItem(HWND hwnd);
//   FindMsgString
void OnFindMsgString(HWND hwnd, LPFINDREPLACE lpFindReplace);
//   WM_NOTIFY
void OnNotify(HWND hwnd, LPNMHDR lpnmhdr);
//   WM_LBUTTONDBLCLK
void OnLButtonDown(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT keyFlags);
//   WM_LBUTTONUP
void OnLButtonUp(HWND hwnd, int x, int y, UINT keyFlags);
//   WM_MOUSEMOVE
void OnMouseMove(HWND hwnd, int x, int y, UINT keyFlags);
//   WM_MOUSEWHEEL
void OnMouseWheel(HWND hwnd, int xPos, int yPos, int zDelta, UINT fwKeys);
//   WM_SYSKEYDOWN/WM_SYSKEYUP
void OnSysKey(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags);

//   
INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

//      :
//   WM_INITDIALOG
BOOL Dialog_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam);
//   WM_CLOSE
void Dialog_OnClose(HWND hwnd);
//   WM_COMMAND
void Dialog_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);

// ,       
HTREEITEM TreeView_FindItem(HWND hwnd, HTREEITEM hParent, LPCTSTR lpText, BOOL fIgnoreCase);
// ,        
void TreeView_DeleteAllCheckedItems(HWND hwnd, HTREEITEM hParent);

// ------------------------------------------------------------------------------------------------
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE, LPTSTR lpszCmdLine, int nCmdShow)
{
    //     ...

    WNDCLASSEX wcex = { sizeof(WNDCLASSEX) };
    wcex.style = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
    wcex.lpfnWndProc = MyWindowProc; //  
    wcex.hInstance = hInstance;
    wcex.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
    wcex.lpszMenuName = MAKEINTRESOURCE(IDR_MENU1);
    wcex.lpszClassName = TEXT("MyWindowClass"); //  
    wcex.hIconSm = LoadIcon(NULL, IDI_APPLICATION);

    if (0 == RegisterClassEx(&wcex)) //  
    {
        //      
        return -1; //   
    } // if

    //  
    //    
    LoadLibrary(TEXT("ComCtl32.dll"));

    //    
    hAccel = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDR_ACCELERATOR1));

    //        
    hWnd = CreateWindowEx(0, TEXT("MyWindowClass"), TEXT("SampleWin32"), WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

    if (NULL == hWnd) //     
    {
        return -1; //   
    } // if

    ShowWindow(hWnd, nCmdShow); //   

    //     ...

    MSG  msg;
    BOOL bRet;

    while ((bRet = GetMessage(&msg, NULL, 0, 0)) != FALSE)
    {
        if (bRet == -1)
        {
            /*        */
        } // if
        else if (!PreTranslateMessage(&msg))
        {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        } // if
    } // while

    return (int)msg.wParam; //   
} // _tWinMain

// ------------------------------------------------------------------------------------------------
LRESULT CALLBACK MyWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hWnd, WM_CREATE, OnCreate);
        HANDLE_MSG(hWnd, WM_DESTROY, OnDestroy);
        HANDLE_MSG(hWnd, WM_SIZE, OnSize);
        HANDLE_MSG(hWnd, WM_COMMAND, OnCommand);
        HANDLE_MSG(hWnd, WM_LBUTTONDBLCLK, OnLButtonDown);
        HANDLE_MSG(hWnd, WM_LBUTTONDOWN, OnLButtonDown);
        HANDLE_MSG(hWnd, WM_LBUTTONUP, OnLButtonUp);
        HANDLE_MSG(hWnd, WM_MOUSEMOVE, OnMouseMove);
        HANDLE_MSG(hWnd, WM_MOUSEWHEEL, OnMouseWheel);
        HANDLE_MSG(hWnd, WM_SYSKEYDOWN, OnSysKey);
        HANDLE_MSG(hWnd, WM_SYSKEYUP, OnSysKey);
    case WM_ADDITEM:
        OnAddItem(hWnd);
        return 0;
    case WM_NOTIFY:
        OnNotify(hWnd, (LPNMHDR)lParam);
        return 0;
    } // switch

    if (uFindMsgString == uMsg) //  FINDMSGSTRING
    {
        OnFindMsgString(hWnd, (LPFINDREPLACE)lParam);
        return 0;
    } // if

    //   
    //    
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
} // MyWindowProc

// ------------------------------------------------------------------------------------------------
BOOL PreTranslateMessage(LPMSG lpMsg)
{
    BOOL bRet = TRUE;

    if (!TranslateAccelerator(hWnd, hAccel, lpMsg))
    {
        bRet = IsDialogMessage(hDlg, lpMsg);

        if (FALSE == bRet)
            bRet = IsDialogMessage(hFindDlg, lpMsg);
    } // if

    return bRet;
} // PreTranslateMessage

// ------------------------------------------------------------------------------------------------
BOOL OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct)
{
    //    
    CreateWindowEx(0, TEXT("SysTreeView32"), NULL, WS_CHILD|WS_VISIBLE|WS_BORDER|TVS_LINESATROOT|TVS_HASLINES|TVS_HASBUTTONS|TVS_SHOWSELALWAYS|TVS_CHECKBOXES,
        10, 10, 250, 410, hwnd, (HMENU)IDC_TREE, lpCreateStruct->hInstance, NULL);

    //   " "
    CreateWindowEx(0, TEXT("Button"), TEXT(" "),
        WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 370, 10, 200, 40, hwnd, (HMENU)ID_NEW_RECORD, lpCreateStruct->hInstance, NULL);

    //   " . "
    CreateWindowEx(0, TEXT("Button"), TEXT(" . "),
        WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 370, 55, 200, 40, hwnd, (HMENU)ID_NEW_RECORD2, lpCreateStruct->hInstance, NULL);

    //   " "
    CreateWindowEx(0, TEXT("Button"), TEXT(" . "),
        WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 370, 100, 200, 40, hwnd, (HMENU)ID_DEL_RECORD, lpCreateStruct->hInstance, NULL);

    //   " "
    CreateWindowEx(0, TEXT("Button"), TEXT(" "),
        WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON, 370, 145, 200, 40, hwnd, (HMENU)ID_FIND_RECORD, lpCreateStruct->hInstance, NULL);

    //  
    CreateWindowEx(0, TEXT("SysLink"), TEXT("<a>  </a>"),
        WS_CHILD|WS_VISIBLE|LWS_TRANSPARENT, 10, 440, 250, 30, hwnd, (HMENU)ID_FORMAT_COLOR, lpCreateStruct->hInstance, NULL);

    return TRUE;
} // OnCreate

// ------------------------------------------------------------------------------------------------
void OnDestroy(HWND hwnd)
{
    PostQuitMessage(0); //   WM_QUIT
} // OnDestroy

// ------------------------------------------------------------------------------------------------
void OnSize(HWND hwnd, UINT state, int cx, int cy)
{
    if (state != SIZE_MINIMIZED)
    {
        //    
        HWND hwndCtl = GetDlgItem(hwnd, IDC_TREE);
        //    
        MoveWindow(hwndCtl, 10, 10, 350, cy-50, TRUE);

        //   
        hwndCtl = GetDlgItem(hwnd, ID_FORMAT_COLOR);
        //  
        MoveWindow(hwndCtl, 10, cy-30, 350, 30, TRUE);
    } // if
} // OnSize

// ------------------------------------------------------------------------------------------------
void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    //    
    HINSTANCE hInstance = GetWindowInstance(hwnd);

    switch (id)
    {
    case ID_NEW_RECORD: //   " "
        {
            //    
            int nDlgResult = DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), hwnd, DialogProc);

            if (IDOK == nDlgResult)
            {
                //     ,    
                SendMessage(hwnd, WM_ADDITEM, 0 ,0);
            } // if
        }
        break;

    case ID_NEW_RECORD2: //   " . "
        //       
        if (IsWindow(hDlg) == FALSE)
        {
            //    
            hDlg = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), hwnd, DialogProc);
            //    
            ShowWindow(hDlg, SW_SHOW);
        } // if
        break;

    case ID_DEL_RECORD: //   " "
        {
            int mbResult = MessageBox(hwnd, TEXT("  ?"), TEXT("SampleWin32"), MB_YESNO|MB_ICONQUESTION);

            if (mbResult == IDYES)
            {
                //    
                HWND hwndCtl = GetDlgItem(hwnd, IDC_TREE);
                //       
                TreeView_DeleteAllCheckedItems(hwndCtl, NULL);
            } // if
        }
        break;

    case ID_FIND_RECORD: //   " "
        if (0 == uFindMsgString)
        {
            //    FINDMSGSTRING
            uFindMsgString = RegisterWindowMessage(FINDMSGSTRING);
        } // if

        //    ""   
        if (IsWindow(hFindDlg) == FALSE)
        {
            findDlg.lStructSize = sizeof(FINDREPLACE);

            findDlg.Flags = FR_HIDEUPDOWN | FR_HIDEWHOLEWORD;

            //    
            findDlg.hInstance = hInstance;
            //    
            findDlg.hwndOwner = hwnd;

            //   
            findDlg.lpstrFindWhat = szBuffer;
            //   
            findDlg.wFindWhatLen = _countof(szBuffer);

            //    ""
            hFindDlg = FindText(&findDlg);
        } // if
        break;

    case ID_FORMAT_COLOR: //    " ..."
        {
            //    
            HWND hwndCtl = GetDlgItem(hwnd, IDC_TREE);

            static COLORREF colors[16]; //  16 

            CHOOSECOLOR c = { sizeof(CHOOSECOLOR) };

            //    
            c.hInstance = (HWND)hInstance;
            //    
            c.hwndOwner = hwnd;
            //       
            c.rgbResult = TreeView_GetTextColor(hwndCtl);
            //   
            c.lpCustColors = colors;
            //   
            c.Flags = CC_FULLOPEN | CC_RGBINIT;

            BOOL bRet = ChooseColor(&c);

            if (FALSE != bRet)
            {
                //      
                TreeView_SetTextColor(hwndCtl, c.rgbResult);
                //   
                UpdateWindow(hwndCtl);
            } // if
        }
        break;
    } // switch
} // OnCommand

// ------------------------------------------------------------------------------------------------
void OnAddItem(HWND hwnd)
{
    //    
    HWND hwndCtl = GetDlgItem(hwnd, IDC_TREE);

    //      

    TVINSERTSTRUCT tvis;

    if (FALSE != fInsertAddItemToRoot)
    {
        tvis.hParent = TVI_ROOT;
    } // if
    else
    {
        //    
        tvis.hParent = TreeView_GetNextSelected(hwndCtl, NULL);
    } // else

    tvis.hInsertAfter = TVI_LAST;

    tvis.item.mask = TVIF_TEXT;
    tvis.item.pszText = szBuffer;

    HTREEITEM hitem = TreeView_InsertItem(hwndCtl, &tvis);

    //   
    TreeView_SelectSetFirstVisible(hwndCtl, hitem);
} // OnAddItem

  // ------------------------------------------------------------------------------------------------
void OnFindMsgString(HWND hwnd, LPFINDREPLACE lpFindReplace)
{
    if (lpFindReplace->Flags & FR_FINDNEXT) //   " "
    {
        //    
        HWND hwndCtl = GetDlgItem(hwnd, IDC_TREE);

        //  ,   "  "
        BOOL fIgnorCase = (lpFindReplace->Flags & FR_MATCHCASE) ? FALSE : TRUE;

        //       
        HTREEITEM hitem = TreeView_FindItem(hwndCtl, NULL, szBuffer, fIgnorCase);

        if (NULL != hitem)
        {
            //   
            TreeView_SetItemState(hwndCtl, TreeView_GetNextSelected(hwndCtl, NULL), 0, TVIS_SELECTED);

            //    
            TreeView_SetItemState(hwndCtl, hitem, TVIS_SELECTED, TVIS_SELECTED);
            //   
            TreeView_SelectSetFirstVisible(hwndCtl, hitem);

            //     
            SetFocus(hwndCtl);
        } // if
        else
        {
            MessageBox(hwnd, TEXT("  "), TEXT("SampleWin32"), MB_OK|MB_ICONINFORMATION);
        } // else
    } // if
} // OnFindMsgString

// ------------------------------------------------------------------------------------------------
void OnNotify(HWND hwnd, LPNMHDR lpnmhdr)
{
    switch (lpnmhdr->code)
    {
    case NM_CLICK:
        if (lpnmhdr->idFrom == ID_FORMAT_COLOR) //   "  "
        {
            OnCommand(hwnd, lpnmhdr->idFrom, lpnmhdr->hwndFrom, 0);
        } // if
        break;

    case TVN_ITEMCHANGED: //     
        if (lpnmhdr->idFrom == IDC_TREE)
        {
            NMTVITEMCHANGE *pnm = (NMTVITEMCHANGE *)lpnmhdr;

            //    
            UINT uStateOld = (pnm->uStateOld & TVIS_STATEIMAGEMASK);
            //    
            UINT uStateNew = (pnm->uStateNew & TVIS_STATEIMAGEMASK);

            if (uStateOld != uStateNew) //  
            {
                //      ...

                //    
                HTREEITEM hitem = TreeView_GetChild(lpnmhdr->hwndFrom, pnm->hItem);

                while (NULL != hitem)
                {
                    //    
                    TreeView_SetItemState(lpnmhdr->hwndFrom, hitem, uStateNew, TVIS_STATEIMAGEMASK);

                    //        
                    hitem = TreeView_GetNextSibling(lpnmhdr->hwndFrom, hitem);
                } // while
            } // if
        } // if
        break;
    } // switch
} // OnNotify

// ------------------------------------------------------------------------------------------------
void OnLButtonDown(HWND hwnd, BOOL fDoubleClick, int x, int y, UINT keyFlags)
{
    //     
    SetFocus(hwnd);

    if (fDoubleClick != FALSE) //  
    {
        if (IsMaximized(hwnd)) //  
        {
            //  
            ShowWindow(hwnd, SW_RESTORE);
        } // if
        else
        {
            //  
            ShowWindow(hwnd, SW_MAXIMIZE);
        } // else
    } // if
    else
    {
        //  ,   
        //       
        SetCapture(hwnd);

        ptDrag.x = x;
        ptDrag.y = y;
    } // else
} // OnLButtonDown

// ------------------------------------------------------------------------------------------------
void OnLButtonUp(HWND hwnd, int x, int y, UINT keyFlags)
{
    ReleaseCapture(); //  
} // OnLButtonUp

// ------------------------------------------------------------------------------------------------
void OnMouseMove(HWND hwnd, int x, int y, UINT keyFlags)
{
    if (GetCapture() == hwnd) //  
    {
        RECT rect; //  

        //   
        GetWindowRect(hwnd, &rect);

        //    

        rect.left += x - ptDrag.x;
        rect.top  += y - ptDrag.y;

        //  
        SetWindowPos(hwnd, NULL, rect.left, rect.top, 0, 0, SWP_NOSIZE);
    } // if
} // OnMouseMove

// ------------------------------------------------------------------------------------------------
void OnMouseWheel(HWND hwnd, int xPos, int yPos, int zDelta, UINT fwKeys)
{
    if (fwKeys & MK_CONTROL) //   Ctrl
    {
        RECT rect; //  

        //   
        GetWindowRect(hwnd, &rect);

        //  

        int d = 5 * zDelta / WHEEL_DELTA;
        InflateRect(&rect, d, d);

        MoveWindow(hwnd, rect.left, rect.top, (rect.right - rect.left), (rect.bottom - rect.top), TRUE);
    } // if
} // OnMouseWheel

// ------------------------------------------------------------------------------------------------
void OnSysKey(HWND hwnd, UINT vk, BOOL fDown, int cRepeat, UINT flags)
{
    RECT rect; //  

    //   
    GetWindowRect(hwnd, &rect);

    if (fDown)
    {
        switch (vk)
        {
        case VK_LEFT: //   
            //   
            SetWindowPos(hwnd, NULL, rect.left - 5, rect.top, 0, 0, SWP_NOSIZE);
            break;

        case VK_RIGHT: //   
            //   
            SetWindowPos(hwnd, NULL, rect.left + 5, rect.top, 0, 0, SWP_NOSIZE);
            break;

        case VK_UP: //   
            //   
            SetWindowPos(hwnd, NULL, rect.left, rect.top - 5, 0, 0, SWP_NOSIZE);
            break;

        case VK_DOWN: //   
            //   
            SetWindowPos(hwnd, NULL, rect.left, rect.top + 5, 0, 0, SWP_NOSIZE);
            break;
        } // switch
    } // if
    else
    {
        switch (vk)
        {
        case VK_LEFT: //   
            //     
            SetWindowPos(hwnd, NULL, 0, rect.top, 0, 0, SWP_NOSIZE);
            break;

        case VK_UP: //   
            //     
            SetWindowPos(hwnd, NULL, rect.left, 0, 0, 0, SWP_NOSIZE);
            break;
        } // switch
    } // else
} // OnSysKey

// ------------------------------------------------------------------------------------------------
INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
    case WM_INITDIALOG:
        {
            BOOL bRet = HANDLE_WM_INITDIALOG(hwndDlg, wParam, lParam, Dialog_OnInitDialog);
            return SetDlgMsgResult(hwndDlg, uMsg, bRet);
        }
    case WM_CLOSE:
        HANDLE_WM_CLOSE(hwndDlg, wParam, lParam, Dialog_OnClose);
        return TRUE;
    case WM_COMMAND:
        HANDLE_WM_COMMAND(hwndDlg, wParam, lParam, Dialog_OnCommand);
        return TRUE;
    } // switch

    return FALSE;
} // DialogProc

// ------------------------------------------------------------------------------------------------
BOOL Dialog_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    //     
    HWND hwndEdit = GetDlgItem(hwnd, IDC_EDIT1);

    //       
    Edit_LimitText(hwndEdit, _countof(szBuffer) - 1);

    //   ()    
    Edit_SetCueBannerText(hwndEdit, L"  ");

    //  
    CheckDlgButton(hwnd, IDC_CHECK_ROOT, BST_CHECKED);

    return TRUE;
} // Dialog_OnInitDialog

// ------------------------------------------------------------------------------------------------
void Dialog_OnClose(HWND hwnd)
{
    if (hwnd == hDlg)
    {
        //    
        DestroyWindow(hwnd);
    } // if
    else
    {
        //     
        EndDialog(hwnd, IDCLOSE);
    } // else
} // Dialog_OnClose

// ------------------------------------------------------------------------------------------------
void Dialog_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDOK: //   ""
    {
        fInsertAddItemToRoot = (IsDlgButtonChecked(hwnd, IDC_CHECK_ROOT) == BST_CHECKED) ? TRUE : FALSE;

        //    
        int cch = GetDlgItemText(hwnd, IDC_EDIT1, szBuffer, _countof(szBuffer));

        if (0 == cch) //     
        {
            //     
            HWND hwndEdit = GetDlgItem(hwnd, IDC_EDIT1);

            EDITBALLOONTIP ebt = { sizeof(EDITBALLOONTIP) };

            ebt.pszTitle = L"SampleWin32";
            ebt.pszText = L"   ";
            ebt.ttiIcon = TTI_WARNING;

            Edit_ShowBalloonTip(hwndEdit, &ebt);
        } // if
        else if (hwnd == hDlg)
        {
            //   
            SetDlgItemText(hwnd, IDC_EDIT1, NULL);
            //  -   ,    
            SendMessage(GetParent(hwnd), WM_ADDITEM, 0, 0);
        } // if
        else
        {
            //     
            EndDialog(hwnd, IDOK);
        } // else
    } // if
    break;

    case IDCANCEL: //   ""
        if (hwnd == hDlg)
        {
            //    
            DestroyWindow(hwnd);
        } // if
        else
        {
            //     
            EndDialog(hwnd, IDCANCEL);
        } // else
        break;
    } // switch
} // Dialog_OnCommand

// ------------------------------------------------------------------------------------------------
HTREEITEM TreeView_FindItem(HWND hwnd, HTREEITEM hParent, LPCTSTR lpText, BOOL fIgnoreCase)
{
    TCHAR szItemText[100];

    TVITEM item;
    item.mask = TVIF_TEXT;

    item.cchTextMax = _countof(szItemText);
    item.pszText = szItemText;

    //    
    item.hItem = TreeView_GetChild(hwnd, hParent);

    while (NULL != item.hItem)
    {
        //     
        BOOL bRet = TreeView_GetItem(hwnd, &item);

        if (FALSE != bRet)
        {
            DWORD dwCmpFlags = (FALSE != fIgnoreCase) ? NORM_IGNORECASE : 0;

            //  
            HRESULT hr = CompareString(LOCALE_USER_DEFAULT, dwCmpFlags, lpText, -1, item.pszText, -1);

            if (CSTR_EQUAL == hr)
            {
                return item.hItem; //  
            } // if
        } // if

        //     
        HTREEITEM hitem = TreeView_FindItem(hwnd, item.hItem, lpText, fIgnoreCase);

        if (NULL != hitem)
        {
            return hitem; //  
        } // if

        //        
        item.hItem = TreeView_GetNextSibling(hwnd, item.hItem);
    } // while

    return NULL;
} // TreeView_FindItem

// ------------------------------------------------------------------------------------------------
void TreeView_DeleteAllCheckedItems(HWND hwnd, HTREEITEM hParent)
{
    //    
    HTREEITEM hitem = TreeView_GetChild(hwnd, hParent);

    while (NULL != hitem)
    {
        //       
        HTREEITEM hti = TreeView_GetNextSibling(hwnd, hitem);

        if (TreeView_GetCheckState(hwnd, hitem)) //  
        {
            //     
            TreeView_DeleteItem(hwnd, hitem);
        } // if
        else
        {
            TreeView_DeleteAllCheckedItems(hwnd, hitem);
        } // else

        //    
        hitem = hti;
    } // while
} // TreeView_DeleteAllCheckedItems
