// Sample2.cpp
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#include <Windows.h>
#include <tchar.h>
#include <stdio.h>
#include <conio.h>
#include <locale.h>
#include <time.h>
#include <process.h>

//      (  )
unsigned __stdcall HandlerRowMatrixInterlockedFunctions(void *lpParameter);

//      (  )
unsigned __stdcall HandlerRowMatrixCriticalSection(void *lpParameter);

//      (     )
unsigned __stdcall HandlerRowMatrixSRWLock(void *lpParameter);

int n_rows; //   
int n_cols; //   

long total = 0; //   
int max = 0, min = 999; //    

CRITICAL_SECTION cs; //  
SRWLOCK SRWLock; //     

// ------------------------------------------------------------------------------------------------
int _tmain()
{
    _tsetlocale(LC_ALL, TEXT(""));

    _tprintf(TEXT("   : "));
    _tscanf_s(TEXT("%d"), &n_rows);

    _tprintf(TEXT("   : "));
    _tscanf_s(TEXT("%d"), &n_cols);

    _tprintf(TEXT("   : \n\
\t1:  \n\
\t2:  \n\
\t3:     \n"));

    int mode = getch();

    _tprintf(TEXT("\n"));

    if ((n_rows > 1) && (n_cols > 1) && ('1' <= mode && mode <= '3'))
    {
        srand((unsigned int)time(NULL));

        //         0  999

        int** matrix = new int*[n_rows];

        for (int i = 0; i < n_rows; ++i)
        {
            matrix[i] = new int[n_cols];

            for (int j = 0; j < n_cols; ++j)
            {
                int value = rand() % 1000; //     0  999
                matrix[i][j] = value;

                _tprintf(TEXT("%3d "), value);
            } // for

            _tprintf(TEXT("\n"));
        } // for

        _tprintf(TEXT("\n"));

        //      
        HANDLE* threads = new HANDLE[n_rows];

        switch (mode)
        {
        case '1': //  
            for (int i = 0; i < n_rows; ++i)
            {
                threads[i] = (HANDLE)_beginthreadex(NULL, 0, HandlerRowMatrixInterlockedFunctions, (void *)matrix[i], 0, NULL);
            } // for
            break;

        case '2': //  
            InitializeCriticalSection(&cs); //   

            for (int i = 0; i < n_rows; ++i)
            {
                threads[i] = (HANDLE)_beginthreadex(NULL, 0, HandlerRowMatrixCriticalSection, (void *)matrix[i], 0, NULL);
            } // for
            break;

        case '3': //     
            InitializeSRWLock(&SRWLock); //  SRWLock

            for (int i = 0; i < n_rows; ++i)
            {
                threads[i] = (HANDLE)_beginthreadex(NULL, 0, HandlerRowMatrixSRWLock, (void *)matrix[i], 0, NULL);
            } // for
            break;
        } // switch

        //     
        WaitForMultipleObjects(n_rows, threads, TRUE, INFINITE);

        //  

        _tprintf(TEXT("  : %d\n"), total);
        _tprintf(TEXT(" : %d\n"), max);
        _tprintf(TEXT(" : %d\n"), min);

        //  

        for (int i = 0; i < n_rows; ++i)
        {
            //   
            delete[] matrix[i];
            //    
            CloseHandle(threads[i]);
        } // for

        //   
        delete[] threads;
        //  
        delete[] matrix;

        if ('2' == mode)
        {
            DeleteCriticalSection(&cs); //   
        } // if
    } // if
} // _tmain

// ------------------------------------------------------------------------------------------------
unsigned __stdcall HandlerRowMatrixInterlockedFunctions(void *lpParameter)
{
    const int *row = (const int *)lpParameter; //  

    int jMax = 0, jMin = 0; //        

    for (int j = 0; j < n_cols; ++j)
    {
        if (9 < row[j] && row[j] < 100) //  
        {
            //      
            InterlockedIncrement(&total);
        } // if

        if (row[j] > row[jMax])
        {
            jMax = j; //    
        } // if
        else if (row[j] < row[jMin])
        {
            jMin = j; //    
        } // if
    } // for

    static long lock = 0; //   

    //   (spinlock)
    //   
    while (InterlockedExchange(&lock, 1) != 0) SwitchToThread();

    if (row[jMax] > max) max = row[jMax]; //   
    if (row[jMin] < min) min = row[jMin]; //   

    InterlockedExchange(&lock, 0); //   

    return 0;
} // HandlerRowMatrixInterlockedFunctions

// ------------------------------------------------------------------------------------------------
unsigned __stdcall HandlerRowMatrixCriticalSection(void *lpParameter)
{
    const int *row = (const int *)lpParameter; //  

    long count = 0; //      
    int jMax = 0, jMin = 0; //        

    for (int j = 0; j < n_cols; ++j)
    {
        if (9 < row[j] && row[j] < 100) //  
        {
            //      
            ++count;
        } // if

        if (row[j] > row[jMax])
        {
            jMax = j; //    
        } // if
        else if (row[j] < row[jMin])
        {
            jMin = j; //    
        } // if
    } // for

    EnterCriticalSection(&cs); //    

    total += count; //    

    if (row[jMax] > max) max = row[jMax]; //   
    if (row[jMin] < min) min = row[jMin]; //   

    LeaveCriticalSection(&cs); //   

    return 0;
} // HandlerRowMatrixCriticalSection

// ------------------------------------------------------------------------------------------------
unsigned __stdcall HandlerRowMatrixSRWLock(void *lpParameter)
{
    const int *row = (const int *)lpParameter; //  

    long count = 0; //      
    int jMax = 0, jMin = 0; //        

    for (int j = 0; j < n_cols; ++j)
    {
        if (9 < row[j] && row[j] < 100) //  
        {
            //      
            ++count;
        } // if

        if (row[j] > row[jMax])
        {
            jMax = j; //    
        } // if
        else if (row[j] < row[jMin])
        {
            jMin = j; //    
        } // if
    } // for

    AcquireSRWLockExclusive(&SRWLock); //   

    total += count; //    

    if (row[jMax] > max) max = row[jMax]; //   
    if (row[jMin] < min) min = row[jMin]; //   

    ReleaseSRWLockExclusive(&SRWLock); //   

    return 0;
} // HandlerRowMatrixSRWLock
