// Sample3.cpp
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#include <Windows.h>
#include <tchar.h>
#include <strsafe.h>
#include <stdio.h>
#include <conio.h>
#include <locale.h>

// ,  
BOOL DuplicateHandle(DWORD dwProcessId, HANDLE hSourceHandle, LPHANDLE lpTargetHandle, DWORD dwDesiredAccess);

// ------------------------------------------------------------------------------------------------
int _tmain(int argc, LPCTSTR argv[])
{
    _tsetlocale(LC_ALL, TEXT(""));

    if (1 == argc) // (!)   
    {
        int n_processes;

        _tprintf(TEXT("  : "));
        _tscanf_s(TEXT("%d"), &n_processes);

        _tprintf(TEXT("   : \n\
\t1:  ()\n\
\t2:  ()\n\
\t3:  ()\n\
\t4:  ()\n\
\t5:  ()\n\
\t6:  ()\n\
\t7:  ()\n\
\t8:  ()\n\
\t9:  ()\n"));

        int mode = getch();

        _tprintf(TEXT("\n"));

        if ((n_processes > 1) && ('1' <= mode && mode <= '9'))
        {
            HANDLE hObject = NULL;
            TCHAR szCmdLine[MAX_PATH + 40];

            if (mode < '4')
            {
                //    

                //    
                //          

                SECURITY_ATTRIBUTES sa = { sizeof(SECURITY_ATTRIBUTES) };
                sa.bInheritHandle = TRUE;

                switch (mode)
                {
                case '1': //   
                    hObject = CreateMutexEx(&sa, NULL, 0, MUTEX_ALL_ACCESS);

                    if (hObject != NULL)
                    {
                        //       
                        StringCchPrintf(szCmdLine, _countof(szCmdLine), TEXT("%s mutex-inherit %p"), argv[0], hObject);
                    } // if
                    break;

                case '2': //   
                    hObject = CreateEventEx(&sa, NULL, CREATE_EVENT_INITIAL_SET, EVENT_ALL_ACCESS);

                    if (hObject != NULL)
                    {
                        //       
                        StringCchPrintf(szCmdLine, _countof(szCmdLine), TEXT("%s event-inherit %p"), argv[0], hObject);
                    } // if
                    break;

                case '3': //   
                    hObject = CreateSemaphoreEx(&sa, 1, 1, NULL, 0, SEMAPHORE_ALL_ACCESS);

                    if (hObject != NULL)
                    {
                        //       
                        StringCchPrintf(szCmdLine, _countof(szCmdLine), TEXT("%s semaphore-inherit %p"), argv[0], hObject);
                    } // if
                    break;
                } // switch
            } // if
            else if (mode < '7')
            {
                //    

                //        
                //          

                switch (mode)
                {
                case '4': //   
                    hObject = CreateMutexEx(NULL, NULL, 0, MUTEX_ALL_ACCESS);

                    if (hObject != NULL)
                    {
                        //       
                        StringCchPrintf(szCmdLine, _countof(szCmdLine), TEXT("%s mutex-duplicate %d %p"), argv[0], (int)GetCurrentProcessId(), hObject);
                    } // if
                    break;

                case '5': //   
                    hObject = CreateEventEx(NULL, NULL, CREATE_EVENT_INITIAL_SET, EVENT_ALL_ACCESS);

                    if (hObject != NULL)
                    {
                        //       
                        StringCchPrintf(szCmdLine, _countof(szCmdLine), TEXT("%s event-duplicate %d %p"), argv[0], (int)GetCurrentProcessId(), hObject);
                    } // if
                    break;

                case '6': //   
                    hObject = CreateSemaphoreEx(NULL, 1, 1, NULL, 0, SEMAPHORE_ALL_ACCESS);

                    if (hObject != NULL)
                    {
                        //       
                        StringCchPrintf(szCmdLine, _countof(szCmdLine), TEXT("%s semaphore-duplicate %d %p"), argv[0], (int)GetCurrentProcessId(), hObject);
                    } // if
                    break;
                } // switch
            } // if
            else
            {
                //    

                switch (mode)
                {
                case '7': //   
                    hObject = CreateMutexEx(NULL, TEXT("SampleMutex"), 0, MUTEX_ALL_ACCESS);

                    if (hObject != NULL)
                    {
                        //       
                        StringCchPrintf(szCmdLine, _countof(szCmdLine), TEXT("%s mutex-named"), argv[0]);
                    } // if
                    break;

                case '8': //   
                    hObject = CreateEventEx(NULL, TEXT("SampleEvent"), CREATE_EVENT_INITIAL_SET, EVENT_ALL_ACCESS);

                    if (hObject != NULL)
                    {
                        //       
                        StringCchPrintf(szCmdLine, _countof(szCmdLine), TEXT("%s event-named"), argv[0]);
                    } // if
                    break;

                case '9': //   
                    hObject = CreateSemaphoreEx(NULL, 1, 1, TEXT("SampleSemaphore"), 0, SEMAPHORE_ALL_ACCESS);

                    if (hObject != NULL)
                    {
                        //       
                        StringCchPrintf(szCmdLine, _countof(szCmdLine), TEXT("%s semaphore-named"), argv[0]);
                    } // if
                    break;
                } // switch
            } // else

            if (hObject != NULL)
            {
                //   
                HANDLE* processes = new HANDLE[n_processes];

                //   ...

                STARTUPINFO si = { sizeof(STARTUPINFO) };
                PROCESS_INFORMATION pi = { 0 };

                for (int i = 0; i < n_processes; ++i)
                {
                    //   
                    BOOL bRet = CreateProcess(NULL, szCmdLine, NULL, NULL, TRUE, CREATE_NEW_CONSOLE, NULL, NULL, &si, &pi);

                    if (FALSE != bRet)
                    {
                        //      
                        processes[i] = pi.hProcess;
                        //     
                        CloseHandle(pi.hThread);
                    } // if
                    else
                    {
                        processes[i] = NULL;
                    } // else
                } // for

                //     
                WaitForMultipleObjects(n_processes, processes, TRUE, INFINITE);

                //    
                for (int i = 0; i < n_processes; ++i) CloseHandle(processes[i]);
                //   
                delete[] processes;

                //  
                CloseHandle(hObject);
            } // if
        } // if
    } // if
    else if (argc > 1) // (!)   
    {
        _tprintf(TEXT(">   :\n"));
        _tprintf(TEXT("> \n"));

        for (int i = 0; i < argc; ++i)
        {
            _tprintf(TEXT("> %s\n"), argv[i]);
        } // for

        if (_tcsnicmp(argv[1], TEXT("mutex-"), 6) == 0)
        {
            HANDLE hMutex = NULL; //  

            if ((3 == argc) && (_tcsicmp(argv[1], TEXT("mutex-inherit")) == 0))
            {
                //       
                hMutex = (HANDLE)_tcstoui64(argv[2], NULL, 16);
            } // if
            else if ((4 == argc) && (_tcsicmp(argv[1], TEXT("mutex-duplicate")) == 0))
            {
                //       
                DWORD dwProcessId = (DWORD)_ttoi(argv[2]);
                //      
                HANDLE hObject = (HANDLE)_tcstoui64(argv[3], NULL, 16);

                //    
                DuplicateHandle(dwProcessId, hObject, &hMutex, MUTEX_ALL_ACCESS);
            } // if
            else if ((2 == argc) && (_tcsicmp(argv[1], TEXT("mutex-named")) == 0))
            {
                //  
                hMutex = OpenMutex(MUTEX_ALL_ACCESS, FALSE, TEXT("SampleMutex"));
            } // if

            if (NULL != hMutex)
            {
                _tprintf(TEXT("> \n"));
                _tprintf(TEXT(">  ():\n"));

                for (int i = 0; i < 3; ++i)
                {
                    //   ,
                    //    
                    WaitForSingleObject(hMutex, INFINITE);

                    for (int j = 0; j < 10; ++j)
                    {
                        _tprintf(TEXT("> %d\n"), j + 1);
                        Sleep(200);
                    } // for

                    //  
                    ReleaseMutex(hMutex);
                } // for

                //   
                CloseHandle(hMutex);
            } // if
        } // if
        else if (_tcsnicmp(argv[1], TEXT("event-"), 6) == 0)
        {
            HANDLE hEvent = NULL; //  

            if ((3 == argc) && (_tcsicmp(argv[1], TEXT("event-inherit")) == 0))
            {
                //       
                hEvent = (HANDLE)_tcstoui64(argv[2], NULL, 16);
            } // if
            else if ((4 == argc) && (_tcsicmp(argv[1], TEXT("event-duplicate")) == 0))
            {
                //       
                DWORD dwProcessId = (DWORD)_ttoi(argv[2]);
                //      
                HANDLE hObject = (HANDLE)_tcstoui64(argv[3], NULL, 16);

                //    
                DuplicateHandle(dwProcessId, hObject, &hEvent, EVENT_ALL_ACCESS);
            } // if
            else if ((2 == argc) && (_tcsicmp(argv[1], TEXT("event-named")) == 0))
            {
                //  
                hEvent = OpenEvent(EVENT_ALL_ACCESS, FALSE, TEXT("SampleEvent"));
            } // if

            if (NULL != hEvent)
            {
                _tprintf(TEXT("> \n"));
                _tprintf(TEXT(">  ():\n"));

                for (int i = 0; i < 3; ++i)
                {
                    //   ,
                    //    
                    WaitForSingleObject(hEvent, INFINITE);

                    for (int j = 0; j < 10; ++j)
                    {
                        _tprintf(TEXT("> %d\n"), j + 1);
                        Sleep(200);
                    } // for

                    //  
                    SetEvent(hEvent);
                } // for

                //   
                CloseHandle(hEvent);
            } // if
        } // if
        else if (_tcsnicmp(argv[1], TEXT("semaphore-"), 10) == 0)
        {
            HANDLE hSemaphore = NULL; //  

            if ((3 == argc) && (_tcsicmp(argv[1], TEXT("semaphore-inherit")) == 0))
            {
                //       
                hSemaphore = (HANDLE)_tcstoui64(argv[2], NULL, 16);
            } // if
            else if ((4 == argc) && (_tcsicmp(argv[1], TEXT("semaphore-duplicate")) == 0))
            {
                //       
                DWORD dwProcessId = (DWORD)_ttoi(argv[2]);
                //      
                HANDLE hObject = (HANDLE)_tcstoui64(argv[3], NULL, 16);

                //    
                DuplicateHandle(dwProcessId, hObject, &hSemaphore, SEMAPHORE_ALL_ACCESS);
            } // if
            else if ((2 == argc) && (_tcsicmp(argv[1], TEXT("semaphore-named")) == 0))
            {
                //  
                hSemaphore = OpenSemaphore(SEMAPHORE_ALL_ACCESS, FALSE, TEXT("SampleSemaphore"));
            } // if

            if (NULL != hSemaphore)
            {
                _tprintf(TEXT("> \n"));
                _tprintf(TEXT(">  ():\n"));

                for (int i = 0; i < 3; ++i)
                {
                    //   ,
                    //    
                    WaitForSingleObject(hSemaphore, INFINITE);

                    for (int j = 0; j < 10; ++j)
                    {
                        _tprintf(TEXT("> %d\n"), j + 1);
                        Sleep(200);
                    } // for

                    //  
                    ReleaseSemaphore(hSemaphore, 1, NULL);
                } // for

                //   
                CloseHandle(hSemaphore);
            } // if
        } // if
    } // if
} // _tmain

// ------------------------------------------------------------------------------------------------
BOOL DuplicateHandle(DWORD dwProcessId, HANDLE hSourceHandle, LPHANDLE lpTargetHandle, DWORD dwDesiredAccess)
{
    BOOL bRet = FALSE;

    //  
    HANDLE hProcess = OpenProcess(PROCESS_DUP_HANDLE, FALSE, dwProcessId);

    if (NULL != hProcess)
    {
        //   
        bRet = DuplicateHandle(hProcess, hSourceHandle, GetCurrentProcess(), lpTargetHandle, dwDesiredAccess, FALSE, 0);

        //   
        CloseHandle(hProcess);
    } // if

    return bRet;
} // DuplicateHandle
