// FileIo.cpp
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#include <Windows.h>

// ----------------------------------------------------------------------------------------------
BOOL ReadAsync(HANDLE hFile, LPVOID lpBuffer, DWORD dwOffset, DWORD dwSize, LPOVERLAPPED lpOverlapped)
{
    //   OVERLAPPED ...

    ZeroMemory(lpOverlapped, sizeof(OVERLAPPED));

    lpOverlapped->Offset = dwOffset;
    lpOverlapped->hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

    //       
    BOOL bRet = ReadFile(hFile, lpBuffer, dwSize, NULL, lpOverlapped);

    if (FALSE == bRet && ERROR_IO_PENDING != GetLastError())
    {
        CloseHandle(lpOverlapped->hEvent), lpOverlapped->hEvent = NULL;
        return FALSE;
    } // if

    return TRUE;
} // ReadAsync

// ----------------------------------------------------------------------------------------------
BOOL WriteAsync(HANDLE hFile, LPCVOID lpBuffer, DWORD dwOffset, DWORD dwSize, LPOVERLAPPED lpOverlapped)
{
    //   OVERLAPPED ...

    ZeroMemory(lpOverlapped, sizeof(OVERLAPPED));

    lpOverlapped->Offset = dwOffset;
    lpOverlapped->hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

    //       
    BOOL bRet = WriteFile(hFile, lpBuffer, dwSize, NULL, lpOverlapped);

    if (FALSE == bRet && ERROR_IO_PENDING != GetLastError())
    {
        CloseHandle(lpOverlapped->hEvent), lpOverlapped->hEvent = NULL;
        return FALSE;
    } // if

    return TRUE;
} // WriteAsync

// ----------------------------------------------------------------------------------------------
BOOL FinishIo(LPOVERLAPPED lpOverlapped)
{
    if (NULL != lpOverlapped->hEvent)
    {
        //    /
        DWORD dwResult = WaitForSingleObject(lpOverlapped->hEvent, INFINITE);

        if (WAIT_OBJECT_0 == dwResult) //  
        {
            CloseHandle(lpOverlapped->hEvent), lpOverlapped->hEvent = NULL;
            return TRUE;
        } // if
    } // if

    return FALSE;
} // FinishIo

// ----------------------------------------------------------------------------------------------
BOOL TryFinishIo(LPOVERLAPPED lpOverlapped)
{
    if (NULL != lpOverlapped->hEvent)
    {
        //    /
        DWORD dwResult = WaitForSingleObject(lpOverlapped->hEvent, 0);

        if (WAIT_OBJECT_0 == dwResult) //  
        {
            CloseHandle(lpOverlapped->hEvent), lpOverlapped->hEvent = NULL;
            return TRUE;
        } // if
    } // if

    return FALSE;
} // TryFinishIo
