// Sample2.cpp
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#include <Windows.h>
#include <WindowsX.h>
#include <tchar.h>
#include <strsafe.h>

#include <shlwapi.h>
#pragma comment(lib, "shlwapi.lib")

#include <SampleRegLibrary.h>

#include "resource.h"

TCHAR szPath[MAX_PATH] = TEXT(""); //   /
DWORD cchPath = 0; //    /

LPCTSTR lpszFileName = NULL; //    /

RECT rect = { 0 }; //    

typedef BOOL (__stdcall *LPSEARCHFUNC)(LPCTSTR lpszFileName, const LPWIN32_FILE_ATTRIBUTE_DATA lpFileAttributeData, LPVOID lpvParam);

//    " "
INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

//   WM_INITDIALOG
BOOL Dialog_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam);
//   WM_CLOSE
void Dialog_OnClose(HWND hwnd);
//   WM_COMMAND
void Dialog_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);

// ,   ,   
BOOL __stdcall CalculateSize(LPCTSTR lpszFileName, const LPWIN32_FILE_ATTRIBUTE_DATA lpFileAttributeData, LPVOID lpvParam);
// ,     
BOOL FileSearch(LPCTSTR lpszFileName, LPCTSTR lpszDirName, LPSEARCHFUNC lpSearchFunc, LPVOID lpvParam);

//        
void StringCchPrintFileSize(LPTSTR lpszBuffer, DWORD cch, ULARGE_INTEGER size);

//     
BOOL GetFileTimeFormat(const LPFILETIME lpFileTime, LPTSTR lpszFileTime, DWORD cchFileTime);

// ----------------------------------------------------------------------------------------------
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE, LPTSTR lpszCmdLine, int nCmdShow)
{
    HKEY hKey = NULL; //   

    DWORD dwDisposition;

    //         
    RegCreateKeyEx(HKEY_CURRENT_USER, TEXT("Software\\Sample2 (OS-Lab4)"),
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_QUERY_VALUE | KEY_SET_VALUE, NULL, &hKey, &dwDisposition);

    // /// //

    if ((NULL != lpszCmdLine) && (_T('\0') != lpszCmdLine[0]))
    {
        //   /   
        StringCchCopy(szPath, _countof(szPath), lpszCmdLine);
        //      
        PathUnquoteSpaces(szPath);
    } // if
    else
    {
        //   /   
        RegGetValueSZ(hKey, TEXT("szPath"), szPath, _countof(szPath), NULL);
    } // else

    WIN32_FILE_ATTRIBUTE_DATA fa;
    BOOL bRet = GetFileAttributesEx(szPath, GetFileExInfoStandard, &fa);

    if (FALSE != bRet)
    {
        //      
        RegGetValueBinary(hKey, TEXT("rect"), (LPBYTE)&rect, sizeof(rect), NULL);

        //   
        //    
        LoadLibrary(TEXT("ComCtl32.dll"));

        int mres;

        if (fa.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
        {
            //    " "
            mres = DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG_DIRECTORY), NULL, DialogProc, (LPARAM)&fa);
        } // if
        else
        {
            //    " "
            mres = DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG_FILE), NULL, DialogProc, (LPARAM)&fa);
        } // else

        if (IDOK == mres)
        {
            //   /   
            RegSetValueSZ(hKey, TEXT("szPath"), szPath);
        } // if

        //      
        RegSetValueBinary(hKey, TEXT("rect"), (LPCBYTE)&rect, sizeof(rect));
    } // if

    // /// //

    //    
    RegCloseKey(hKey);
} // _tWinMain

// ----------------------------------------------------------------------------------------------
INT_PTR CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
    case WM_INITDIALOG:
    {
        BOOL bRet = HANDLE_WM_INITDIALOG(hwndDlg, wParam, lParam, Dialog_OnInitDialog);
        return SetDlgMsgResult(hwndDlg, uMsg, bRet);
    }

    case WM_CLOSE:
        HANDLE_WM_CLOSE(hwndDlg, wParam, lParam, Dialog_OnClose);
        return TRUE;

    case WM_COMMAND:
        HANDLE_WM_COMMAND(hwndDlg, wParam, lParam, Dialog_OnCommand);
        return TRUE;
    } // switch

    return FALSE;
} // DialogProc

// ----------------------------------------------------------------------------------------------
BOOL Dialog_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    if (IsRectEmpty(&rect) == FALSE)
    {
        //   
        SetWindowPos(hwnd, NULL, rect.left, rect.top, 0, 0, SWP_NOSIZE);
    } // if

    LPWIN32_FILE_ATTRIBUTE_DATA lpfa = (LPWIN32_FILE_ATTRIBUTE_DATA)lParam;
    TCHAR szBuffer[100];

    //     
    ULARGE_INTEGER size = { 0 };
    CalculateSize(szPath, lpfa, &size);

    //      /
    lpszFileName = PathFindFileName(szPath);

    //     /
    cchPath = (DWORD)(lpszFileName - szPath) - 1;
    //  -    /
    szPath[cchPath] = _T('\0');

    //      /
    SendDlgItemMessage(hwnd, IDC_EDIT_FILENAME, EM_LIMITTEXT, (WPARAM)_countof(szPath), 0);
    //   /   
    SetDlgItemText(hwnd, IDC_EDIT_FILENAME, lpszFileName);

    //    /   
    SetDlgItemText(hwnd, IDC_EDIT_PATH, szPath); // 

    //     /
    StringCchPrintFileSize(szBuffer, _countof(szBuffer), size);
    //     
    SetDlgItemText(hwnd, IDC_EDIT_FILESIZE, szBuffer); // 

    //       
    GetFileTimeFormat(&lpfa->ftCreationTime, szBuffer, _countof(szBuffer));
    //     
    SetDlgItemText(hwnd, IDC_EDIT_CREATIONTIME, szBuffer); //  

    //        
    GetFileTimeFormat(&lpfa->ftLastWriteTime, szBuffer, _countof(szBuffer));
    //     
    SetDlgItemText(hwnd, IDC_EDIT_LASTWRITETIM, szBuffer); //   

    //        
    GetFileTimeFormat(&lpfa->ftLastAccessTime, szBuffer, _countof(szBuffer));
    //     
    SetDlgItemText(hwnd, IDC_EDIT_LASTACCESSTIME, szBuffer); //   

    //  
    constexpr DWORD attr[] = {
        FILE_ATTRIBUTE_READONLY, FILE_ATTRIBUTE_HIDDEN, FILE_ATTRIBUTE_ARCHIVE,
        FILE_ATTRIBUTE_SYSTEM, FILE_ATTRIBUTE_TEMPORARY, FILE_ATTRIBUTE_COMPRESSED, FILE_ATTRIBUTE_ENCRYPTED
    };

    //     
    constexpr DWORD ids[] = {
        IDC_ATTRIBUTE_READONLY, IDC_ATTRIBUTE_HIDDEN, IDC_ATTRIBUTE_ARCHIVE,
        IDC_ATTRIBUTE_SYSTEM, IDC_ATTRIBUTE_TEMPORARY, IDC_ATTRIBUTE_COMPRESSED, IDC_ATTRIBUTE_ENCRYPTED
    };

    //       /

    for (int i = 0; i < _countof(attr); ++i)
    {
        UINT uCheck = (lpfa->dwFileAttributes & attr[i]) ? BST_CHECKED : BST_UNCHECKED;
        CheckDlgButton(hwnd, ids[i], uCheck);
    } // for

    UINT uCheck = (lpfa->dwFileAttributes & FILE_ATTRIBUTE_NOT_CONTENT_INDEXED) ? BST_UNCHECKED : BST_CHECKED;
    CheckDlgButton(hwnd, IDC_ATTRIBUTE_CONTENT_INDEXED, uCheck);

    return TRUE;
} // Dialog_OnInitDialog

// ----------------------------------------------------------------------------------------------
void Dialog_OnClose(HWND hwnd)
{
    //     
    GetWindowRect(hwnd, &rect);

    //    
    EndDialog(hwnd, IDCLOSE);
} // Dialog_OnClose

// ----------------------------------------------------------------------------------------------
void Dialog_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDOK:
    {
        TCHAR szNewFileName[MAX_PATH]; //   /
        //   /   
        GetDlgItemText(hwnd, IDC_EDIT_FILENAME, szNewFileName, _countof(szNewFileName));

        if (CompareString(LOCALE_USER_DEFAULT, 0, lpszFileName, -1, szNewFileName, -1) != CSTR_EQUAL) // (!)   /
        {
            TCHAR szExistingFileName[MAX_PATH]; //   /
            StringCchPrintf(szExistingFileName, _countof(szExistingFileName), TEXT("%s\\%s"), szPath, lpszFileName);

            //     /
            PathAppend(szPath, szNewFileName);
            //  /
            MoveFile(szExistingFileName, szPath);
        } // if
        else
        {
            //  -,     /
            szPath[cchPath] = _T('\\');
        } // else

        // /// //

        //  
        constexpr DWORD attr[] = {
            FILE_ATTRIBUTE_READONLY, FILE_ATTRIBUTE_HIDDEN, FILE_ATTRIBUTE_ARCHIVE,
            FILE_ATTRIBUTE_SYSTEM, FILE_ATTRIBUTE_TEMPORARY, FILE_ATTRIBUTE_COMPRESSED, FILE_ATTRIBUTE_ENCRYPTED
        };

        //     
        constexpr DWORD ids[] = {
            IDC_ATTRIBUTE_READONLY, IDC_ATTRIBUTE_HIDDEN, IDC_ATTRIBUTE_ARCHIVE,
            IDC_ATTRIBUTE_SYSTEM, IDC_ATTRIBUTE_TEMPORARY, IDC_ATTRIBUTE_COMPRESSED, IDC_ATTRIBUTE_ENCRYPTED
        };

        DWORD dwFileAttributes = 0; //  /

        // ,   

        for (int i = 0; i < _countof(attr); ++i)
        {
            if (IsDlgButtonChecked(hwnd, ids[i]) == BST_CHECKED) //  
            {
                dwFileAttributes |= attr[i]; //   
            } // if
        } // for

        if (IsDlgButtonChecked(hwnd, IDC_ATTRIBUTE_CONTENT_INDEXED) == BST_UNCHECKED) //  
        {
            dwFileAttributes |= FILE_ATTRIBUTE_NOT_CONTENT_INDEXED; //   
        } // if

        //  
        SetFileAttributes(szPath, dwFileAttributes);

        // /// //

        //     
        GetWindowRect(hwnd, &rect);

        //    
        EndDialog(hwnd, IDOK);
    }
    break;

    case IDCANCEL:
    {
        //     
        GetWindowRect(hwnd, &rect);

        //    
        EndDialog(hwnd, IDCANCEL);
    }
    break;
    } // switch
} // Dialog_OnCommand

// ----------------------------------------------------------------------------------------------
BOOL __stdcall CalculateSize(LPCTSTR lpszFileName, const LPWIN32_FILE_ATTRIBUTE_DATA lpFileAttributeData, LPVOID lpvParam)
{
    if (lpFileAttributeData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
    {
        //    
        return FileSearch(TEXT("*"), lpszFileName, CalculateSize, lpvParam);
    } // if

    //      

    ULARGE_INTEGER size = { lpFileAttributeData->nFileSizeLow, lpFileAttributeData->nFileSizeHigh };
    ((ULARGE_INTEGER *)lpvParam)->QuadPart += size.QuadPart;

    return TRUE; //  TRUE,   
} // CalculateSize

// ----------------------------------------------------------------------------------------------
BOOL FileSearch(LPCTSTR lpszFileName, LPCTSTR lpszDirName, LPSEARCHFUNC lpSearchFunc, LPVOID lpvParam)
{
    WIN32_FIND_DATA fd;
    TCHAR szFileName[MAX_PATH];

    //   
    StringCchPrintf(szFileName, MAX_PATH, TEXT("%s\\%s"), lpszDirName, lpszFileName);

    //  
    HANDLE hFindFile = FindFirstFile(szFileName, &fd);
    if (INVALID_HANDLE_VALUE == hFindFile) return FALSE;

    BOOL bRet = TRUE;

    for (BOOL bFindNext = TRUE; FALSE != bFindNext; bFindNext = FindNextFile(hFindFile, &fd))
    {
        if (_tcscmp(fd.cFileName, TEXT(".")) == 0 || _tcscmp(fd.cFileName, TEXT("..")) == 0)
        {
            /*      */
            continue;
        } // if

        //     /
        StringCchPrintf(szFileName, MAX_PATH, TEXT("%s\\%s"), lpszDirName, fd.cFileName);

        bRet = lpSearchFunc(szFileName, (LPWIN32_FILE_ATTRIBUTE_DATA)&fd, lpvParam);
        if (FALSE == bRet) break; //  
    } // for

    FindClose(hFindFile); //  
    return bRet;
} // FileSearch

// ----------------------------------------------------------------------------------------------
void StringCchPrintFileSize(LPTSTR lpszBuffer, DWORD cch, ULARGE_INTEGER size)
{
    if (size.QuadPart >= 0x40000000ULL)
    {
        StringCchPrintf(lpszBuffer, cch, TEXT("%.1f "), (size.QuadPart / (float)0x40000000ULL));
    } // if
    else if (size.QuadPart >= 0x100000ULL)
    {
        StringCchPrintf(lpszBuffer, cch, TEXT("%.1f "), (size.QuadPart / (float)0x100000ULL));
    } // if
    else if (size.QuadPart >= 0x0400ULL)
    {
        StringCchPrintf(lpszBuffer, cch, TEXT("%.1f "), (size.QuadPart / (float)0x0400ULL));
    } // if
    else
    {
        StringCchPrintf(lpszBuffer, cch, TEXT("%u "), size.LowPart);
    } // else

    size_t len = _tcslen(lpszBuffer);

    if (len < cch)
    {
        StringCchPrintf((lpszBuffer + len), (cch - len), TEXT(" (%llu )"), size.QuadPart);
    } // if
} // StringCchPrintFileSize

// ----------------------------------------------------------------------------------------------
BOOL GetFileTimeFormat(const LPFILETIME lpFileTime, LPTSTR lpszFileTime, DWORD cchFileTime)
{
    SYSTEMTIME st;

    //      FILETIME  SYSTEMTIME
    BOOL bRet = FileTimeToSystemTime(lpFileTime, &st);

    //        
    if (FALSE != bRet)
        bRet = SystemTimeToTzSpecificLocalTime(NULL, &st, &st);

    if (FALSE != bRet)
    {
        //     
        GetDateFormat(LOCALE_USER_DEFAULT, DATE_LONGDATE, &st, NULL, lpszFileTime, cchFileTime);

        //     

        StringCchCat(lpszFileTime, cchFileTime, TEXT(", "));
        DWORD len = _tcslen(lpszFileTime);

        if (len < cchFileTime)
            GetTimeFormat(LOCALE_USER_DEFAULT, TIME_FORCE24HOURFORMAT, &st, NULL, lpszFileTime+len, cchFileTime-len);
    } // if

    return bRet;
} // GetFileTimeFormat
