// Sample2.cpp
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#include <Windows.h>
#include <WindowsX.h>
#include <tchar.h>
#include <strsafe.h>

#include <Psapi.h>
#pragma comment(lib, "Psapi.lib")

#include <SecurityLibrary.h>

#define IDC_LIST_PROCESSES              2001
#define IDC_LIST_GROUPS                 2002
#define IDC_LIST_PRIVILEGES             2003
#define IDC_EDIT_ACCOUNT                2004
#define IDC_EDIT_ACCOUNT_SID            2005
#define IDC_COMBO_PRIVILEGES            2006
#define IDC_BUTTON_PRIVILEGE_EXISTS     2007
#define IDC_BUTTON_PRIVILEGE_ENABLE     2008
#define IDC_BUTTON_PRIVILEGE_DISABLE    2009

//    
LRESULT CALLBACK MyWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

//   WM_CREATE
BOOL OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct);
//   WM_DESTROY
void OnDestroy(HWND hwnd);
//   WM_SIZE
void OnSize(HWND hwnd, UINT state, int cx, int cy);
//   WM_COMMAND
void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);

// ,   
void LoadProcessesToListBox(HWND hwndCtl);
// ,  ,    
void LoadTokenGroupsToListBox(HWND hwndCtl, HANDLE hToken);
// ,  ,    
void LoadTokenPrivilegesToListBox(HWND hwndCtl, HANDLE hToken);

// ------------------------------------------------------------------------------------------------
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE, LPTSTR lpszCmdLine, int nCmdShow)
{
    //      ...

    WNDCLASSEX wcex = { sizeof(WNDCLASSEX) };

    wcex.style = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
    wcex.lpfnWndProc = MyWindowProc; //  
    wcex.hInstance = hInstance;
    wcex.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
    wcex.lpszMenuName = NULL;
    wcex.lpszClassName = TEXT("MyWindowClass"); //  
    wcex.hIconSm = LoadIcon(NULL, IDI_APPLICATION);

    if (0 == RegisterClassEx(&wcex)) //  
    {
        //      
        return -1; //   
    } // if

    //   
    //    
    LoadLibrary(TEXT("ComCtl32.dll"));

    //        

    HWND hWnd = CreateWindowEx(0, TEXT("MyWindowClass"), TEXT("Sample2"), WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

    if (NULL == hWnd)
    {
        //     
        return -1; //   
    } // if

    ShowWindow(hWnd, nCmdShow); //   

    //     ...

    MSG  msg;
    BOOL bRet;

    while ((bRet = GetMessage(&msg, NULL, 0, 0)) != FALSE)
    {
        if (bRet == -1)
        {
            /*        */
        } // if
        else
        {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        } // else
    } // while

    return (int)msg.wParam;
} // _tWinMain

// ------------------------------------------------------------------------------------------------
LRESULT CALLBACK MyWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hWnd, WM_CREATE, OnCreate);
        HANDLE_MSG(hWnd, WM_DESTROY, OnDestroy);
        HANDLE_MSG(hWnd, WM_SIZE, OnSize);
        HANDLE_MSG(hWnd, WM_COMMAND, OnCommand);
    } // switch

    //   
    //    
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
} // MyWindowProc

// ------------------------------------------------------------------------------------------------
BOOL OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct)
{
    //     

    CreateWindowEx(0, TEXT("Static"), TEXT(":"), WS_CHILD | WS_VISIBLE | SS_SIMPLE,
        10, 10, 400, 20, hwnd, NULL, lpCreateStruct->hInstance, NULL);

    HWND hwndCtl = CreateWindowEx(0, TEXT("ListBox"), TEXT(""), WS_CHILD | WS_VISIBLE | LBS_STANDARD,
        10, 30, 400, 400, hwnd, (HMENU)IDC_LIST_PROCESSES, lpCreateStruct->hInstance, NULL);

    //   
    LoadProcessesToListBox(hwndCtl);

    // /// //

    //   ""

    CreateWindowEx(0, TEXT("Static"), TEXT(":"), WS_CHILD | WS_VISIBLE | SS_SIMPLE,
        420, 30, 110, 20, hwnd, NULL, lpCreateStruct->hInstance, NULL);

    CreateWindowEx(0, TEXT("Edit"), TEXT(""), WS_CHILD | WS_VISIBLE | ES_LEFT | ES_READONLY | ES_AUTOHSCROLL,
        570, 30, 400, 20, hwnd, (HMENU)IDC_EDIT_ACCOUNT, lpCreateStruct->hInstance, NULL);

    //   "SID"

    CreateWindowEx(0, TEXT("Static"), TEXT("SID:"), WS_CHILD | WS_VISIBLE | SS_SIMPLE,
        420, 50, 110, 20, hwnd, NULL, lpCreateStruct->hInstance, NULL);

    CreateWindowEx(0, TEXT("Edit"), TEXT(""), WS_CHILD | WS_VISIBLE | ES_LEFT | ES_READONLY | ES_AUTOHSCROLL,
        570, 50, 400, 20, hwnd, (HMENU)IDC_EDIT_ACCOUNT_SID, lpCreateStruct->hInstance, NULL);

    //     

    CreateWindowEx(0, TEXT("Static"), TEXT(":"), WS_CHILD | WS_VISIBLE | SS_SIMPLE,
        420, 80, 400, 20, hwnd, NULL, lpCreateStruct->hInstance, NULL);

    hwndCtl = CreateWindowEx(0, TEXT("ListBox"), TEXT(""), WS_CHILD | WS_VISIBLE | LBS_STANDARD,
        420, 100, 400, 200, hwnd, (HMENU)IDC_LIST_GROUPS, lpCreateStruct->hInstance, NULL);

    // /// //

    //     

    CreateWindowEx(0, TEXT("Static"), TEXT(":"), WS_CHILD|WS_VISIBLE|SS_SIMPLE,
        420, 310, 400, 20, hwnd, NULL, lpCreateStruct->hInstance, NULL);

    hwndCtl = CreateWindowEx(0, TEXT("ListBox"), TEXT(""), WS_CHILD | WS_VISIBLE | LBS_STANDARD,
        420, 330, 400, 200, hwnd, (HMENU)IDC_LIST_PRIVILEGES, lpCreateStruct->hInstance, NULL);

    //   ""
    hwndCtl = CreateWindowEx(0, TEXT("Button"), TEXT(""), WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
        420, 535, 110, 30, hwnd, (HMENU)IDC_BUTTON_PRIVILEGE_ENABLE, lpCreateStruct->hInstance, NULL);
    //   ""
    EnableWindow(hwndCtl, FALSE);

    //   ""
    hwndCtl = CreateWindowEx(0, TEXT("Button"), TEXT(""), WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
        530, 535, 110, 30, hwnd, (HMENU)IDC_BUTTON_PRIVILEGE_DISABLE, lpCreateStruct->hInstance, NULL);
    //   ""
    EnableWindow(hwndCtl, FALSE);

    // /// //

    //    ""
    hwndCtl = CreateWindowEx(0, TEXT("ComboBox"), TEXT(""), WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST,
        420, 580, 400, 30, hwnd, (HMENU)IDC_COMBO_PRIVILEGES, lpCreateStruct->hInstance, NULL);

    //  
    constexpr LPCTSTR aPrivileges[34] = {
        SE_ASSIGNPRIMARYTOKEN_NAME,
        SE_AUDIT_NAME,
        SE_BACKUP_NAME,
        SE_CHANGE_NOTIFY_NAME,
        SE_CREATE_GLOBAL_NAME,
        SE_CREATE_PAGEFILE_NAME,
        SE_CREATE_PERMANENT_NAME,
        SE_CREATE_SYMBOLIC_LINK_NAME,
        SE_CREATE_TOKEN_NAME,
        SE_DEBUG_NAME,
        SE_ENABLE_DELEGATION_NAME,
        SE_IMPERSONATE_NAME,
        SE_INC_BASE_PRIORITY_NAME,
        SE_INCREASE_QUOTA_NAME,
        SE_INC_WORKING_SET_NAME,
        SE_LOAD_DRIVER_NAME,
        SE_LOCK_MEMORY_NAME,
        SE_MACHINE_ACCOUNT_NAME,
        SE_MANAGE_VOLUME_NAME,
        SE_PROF_SINGLE_PROCESS_NAME,
        SE_RELABEL_NAME,
        SE_REMOTE_SHUTDOWN_NAME,
        SE_RESTORE_NAME,
        SE_SECURITY_NAME,
        SE_SHUTDOWN_NAME,
        SE_SYNC_AGENT_NAME,
        SE_SYSTEM_ENVIRONMENT_NAME,
        SE_SYSTEM_PROFILE_NAME,
        SE_SYSTEMTIME_NAME,
        SE_TAKE_OWNERSHIP_NAME,
        SE_TCB_NAME,
        SE_TIME_ZONE_NAME,
        SE_TRUSTED_CREDMAN_ACCESS_NAME,
        SE_UNDOCK_NAME
    };

    for (int i = 0; i < _countof(aPrivileges); ++i)
    {
        //     
        ComboBox_AddString(hwndCtl, aPrivileges[i]);
    } // for

    //     
    ComboBox_SetCurSel(hwndCtl, 0);

    //   ""
    CreateWindowEx(0, TEXT("Button"), TEXT(""), WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
        420, 615, 110, 30, hwnd, (HMENU)IDC_BUTTON_PRIVILEGE_EXISTS, lpCreateStruct->hInstance, NULL);

    return TRUE;
} // OnCreate

// --------------------------------------------------------------
void OnSize(HWND hwnd, UINT state, int cx, int cy)
{
    if (state != SIZE_MINIMIZED)
    {
        //    
        MoveWindow(GetDlgItem(hwnd, IDC_LIST_PROCESSES), 10, 30, 400, cy - 40, TRUE);
        //    
        MoveWindow(GetDlgItem(hwnd, IDC_LIST_GROUPS), 420, 100, cx - 430, 200, TRUE);
        //    
        MoveWindow(GetDlgItem(hwnd, IDC_LIST_PRIVILEGES), 420, 330, cx - 430, 200, TRUE);

        //    ""
        MoveWindow(GetDlgItem(hwnd, IDC_EDIT_ACCOUNT), 570, 30, cx - 580, 20, TRUE);
        //    "SID"
        MoveWindow(GetDlgItem(hwnd, IDC_EDIT_ACCOUNT_SID), 570, 50, cx - 580, 20, TRUE);

        //     ""
        MoveWindow(GetDlgItem(hwnd, IDC_COMBO_PRIVILEGES), 420, 580, cx - 430, 30, TRUE);
    } // if
} // OnSize

// ------------------------------------------------------------------------------------------------
void OnDestroy(HWND hwnd)
{
    PostQuitMessage(0); //   WM_QUIT
} // OnDestroy

// ------------------------------------------------------------------------------------------------
void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDC_LIST_PROCESSES:
        if (LBN_SELCHANGE == codeNotify) //      
        {
            //   ""
            SetDlgItemText(hwnd, IDC_EDIT_ACCOUNT, NULL);
            //   "SID"
            SetDlgItemText(hwnd, IDC_EDIT_ACCOUNT_SID, NULL);

            HWND hwndListGroups = GetDlgItem(hwnd, IDC_LIST_GROUPS);
            //   
            ListBox_ResetContent(hwndListGroups);

            HWND hwndListPrivileges = GetDlgItem(hwnd, IDC_LIST_PRIVILEGES);
            //  
            ListBox_ResetContent(hwndListPrivileges);

            //   ""
            EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_PRIVILEGE_ENABLE), FALSE);
            //   ""
            EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_PRIVILEGE_DISABLE), FALSE);

            // //// //

            //    
            int iItem = ListBox_GetCurSel(hwndCtl);

            if (iItem != -1)
            {
                //   
                DWORD dwProcessId = (DWORD)ListBox_GetItemData(hwndCtl, iItem);

                //    
                HANDLE hToken = OpenProcessTokenByProcessId(dwProcessId, TOKEN_QUERY);

                if (NULL != hToken)
                {
                    PSID pSid = NULL;

                    //  SID 
                    BOOL bRet = GetTokenUser(hToken, &pSid);

                    if (FALSE != bRet)
                    {
                        LPTSTR lpString = NULL;

                        //       SID
                        GetAccountName(pSid, &lpString);

                        if (NULL != lpString)
                        {
                            //    
                            SetDlgItemText(hwnd, IDC_EDIT_ACCOUNT, lpString);
                            //   
                            LocalFree(lpString), lpString = NULL;
                        } // if

                        //  SID  
                        ConvertSidToStringSid(pSid, &lpString);

                        if (NULL != lpString)
                        {
                            //  SID  
                            SetDlgItemText(hwnd, IDC_EDIT_ACCOUNT_SID, lpString);
                            //   
                            LocalFree(lpString), lpString = NULL;
                        } // if

                        //   
                        LocalFree(pSid), pSid = NULL;
                    } // if

                    //  
                    LoadTokenGroupsToListBox(hwndListGroups, hToken);

                    //  
                    LoadTokenPrivilegesToListBox(hwndListPrivileges, hToken);

                    //    
                    CloseHandle(hToken);
                } // if
            } // if
        } // if
        break;

    case IDC_LIST_PRIVILEGES:
        if (LBN_SELCHANGE == codeNotify) //      
        {
            //    
            int iItem = ListBox_GetCurSel(hwndCtl);

            if (iItem != -1)
            {
                //   
                DWORD dwAttributes = (DWORD)ListBox_GetItemData(hwndCtl, iItem);

                if (dwAttributes & SE_PRIVILEGE_ENABLED)
                {
                    //   ""
                    EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_PRIVILEGE_ENABLE), FALSE);
                    //   ""
                    EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_PRIVILEGE_DISABLE), TRUE);
                } // if
                else
                {
                    //   ""
                    EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_PRIVILEGE_ENABLE), TRUE);
                    //   ""
                    EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_PRIVILEGE_DISABLE), FALSE);
                } // else
            } // if
        } // if
        break;

    case IDC_BUTTON_PRIVILEGE_ENABLE: //  
    case IDC_BUTTON_PRIVILEGE_DISABLE: //  
    {
        //  
        HWND hwndList = GetDlgItem(hwnd, IDC_LIST_PROCESSES);
        //  
        HWND hwndListPrivileges = GetDlgItem(hwnd, IDC_LIST_PRIVILEGES);

        DWORD dwProcessId; //  

        //    
        int iItem = ListBox_GetCurSel(hwndList);

        if (iItem != -1)
        {
            //   
            dwProcessId = (DWORD)ListBox_GetItemData(hwndList, iItem);

            //    
            iItem = ListBox_GetCurSel(hwndListPrivileges);
        } // if

        if (iItem != -1)
        {
            //    
            HANDLE hToken = OpenProcessTokenByProcessId(dwProcessId, TOKEN_QUERY | TOKEN_ADJUST_PRIVILEGES);

            if (NULL != hToken)
            {
                TCHAR szPrivilege[256]; //  

                //   
                ListBox_GetText(hwndListPrivileges, iItem, szPrivilege);

                //  ,  ,   
                LPTSTR p = _tcschr(szPrivilege, TEXT(' '));
                if (NULL != p) *p = TEXT('\0');

                //   
                BOOL bRet = EnablePrivilege(hToken, szPrivilege, (IDC_BUTTON_PRIVILEGE_ENABLE == id) ? TRUE : FALSE);

                if (FALSE != bRet)
                {
                    //   
                    LoadTokenPrivilegesToListBox(hwndListPrivileges, hToken);

                    //     
                    ListBox_SetCurSel(hwndListPrivileges, iItem);
                    //     
                    SetFocus(hwndListPrivileges);

                    if (IDC_BUTTON_PRIVILEGE_ENABLE == id) //   
                    {
                        //   ""
                        EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_PRIVILEGE_ENABLE), FALSE);
                        //   ""
                        EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_PRIVILEGE_DISABLE), TRUE);
                    } // if
                    else //   
                    {
                        //   ""
                        EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_PRIVILEGE_ENABLE), TRUE);
                        //   ""
                        EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_PRIVILEGE_DISABLE), FALSE);
                    } // else
                } // if
                else
                {
                    MessageBox(hwnd, TEXT("    "), NULL, MB_OK | MB_ICONWARNING);
                } // else

                //    
                CloseHandle(hToken);
            } // if
        } // if
    }
    break;

    case IDC_BUTTON_PRIVILEGE_EXISTS: //   
    {
        //  
        HWND hwndList = GetDlgItem(hwnd, IDC_LIST_PROCESSES);
        //   
        HWND hwndCB = GetDlgItem(hwnd, IDC_COMBO_PRIVILEGES);

        DWORD dwProcessId; //  

        //    
        int iItem = ListBox_GetCurSel(hwndList);

        if (iItem != -1)
        {
            //   
            dwProcessId = (DWORD)ListBox_GetItemData(hwndList, iItem);

            //    
            iItem = ComboBox_GetCurSel(hwndCB);
        } // if

        if (iItem != -1)
        {
            //    
            HANDLE hToken = OpenProcessTokenByProcessId(dwProcessId, TOKEN_QUERY);

            if (NULL != hToken)
            {
                TCHAR szPrivilege[256]; //  

                //   
                ComboBox_GetLBText(hwndCB, iItem, szPrivilege);

                //   
                BOOL bRet = IsPrivilegeExists(hToken, szPrivilege);

                if (bRet == -1) // (!) 
                {
                    MessageBox(hwnd, TEXT("      "), NULL, MB_OK | MB_ICONERROR);
                } // if
                else if (FALSE == bRet)
                {
                    MessageBox(hwnd, TEXT("  "), TEXT("Sample 2"), MB_OK | MB_ICONWARNING);
                } // if
                else
                {
                    //   
                    bRet = IsPrivilegeEnabled(hToken, szPrivilege);

                    if (bRet == -1) // (!) 
                    {
                        MessageBox(hwnd, TEXT("    "), NULL, MB_OK | MB_ICONERROR);
                    } // if
                    else if (FALSE != bRet)
                    {
                        MessageBox(hwnd, TEXT(" ."), TEXT("Sample 2"), MB_OK | MB_ICONINFORMATION);
                    } // if
                    else
                    {
                        MessageBox(hwnd, TEXT(" ."), TEXT("Sample 2"), MB_OK | MB_ICONINFORMATION);
                    } // else
                } // else

                //    
                CloseHandle(hToken);
            } // if
            else
            {
                MessageBox(hwnd, TEXT("    "), NULL, MB_OK | MB_ICONERROR);
            } // else
        } // if
    }
    break;
    } // switch
} // OnCommand

// ------------------------------------------------------------------------------------------------
void LoadProcessesToListBox(HWND hwndCtl)
{
    //     
    ListBox_ResetContent(hwndCtl);

    //      
    DWORD aProcessIds[1024], cbNeeded = 0;
    BOOL bRet = EnumProcesses(aProcessIds, sizeof(aProcessIds), &cbNeeded);

    if (FALSE != bRet)
    {
        TCHAR szName[MAX_PATH], szBuffer[300];

        for (DWORD i = 0, 
            n = cbNeeded / sizeof(DWORD); i < n; ++i)
        {
            DWORD dwProcessId = aProcessIds[i], cch = 0;
            if (0 == dwProcessId) continue;

            //    ""
            HANDLE hProcess = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, dwProcessId);

            if (NULL != hProcess)
            {
                //     
                cch = GetModuleBaseName(hProcess, NULL, szName, _countof(szName));
                CloseHandle(hProcess); //   
            } // if

            if (0 == cch)
                StringCchCopy(szName, MAX_PATH, TEXT(" "));

            //    
            StringCchPrintf(szBuffer, _countof(szBuffer), TEXT("%s (PID: %u)"), szName, dwProcessId);

            //     
            int iItem = ListBox_AddString(hwndCtl, szBuffer);
            //      
            ListBox_SetItemData(hwndCtl, iItem, dwProcessId);
        } // for
    } // if
} // LoadProcessesToListBox

// ------------------------------------------------------------------------------------------------
void LoadTokenGroupsToListBox(HWND hwndCtl, HANDLE hToken)
{
    //     
    ListBox_ResetContent(hwndCtl);

    PTOKEN_GROUPS pTokenGroups = NULL;
    BOOL bRet = GetTokenGroups(hToken, &pTokenGroups); //   

    if (FALSE != bRet)
    {
        for (DWORD i = 0; i < pTokenGroups->GroupCount; ++i)
        {
            LPTSTR lpString = NULL;

            //       SID
            GetAccountName(pTokenGroups->Groups[i].Sid, &lpString);

            if (NULL != lpString)
            {
                //     
                ListBox_AddString(hwndCtl, lpString);
                //   
                LocalFree(lpString), lpString = NULL;
            } // if
        } // for

        //   
        LocalFree(pTokenGroups);
    } // if
} // LoadTokenGroupsToListBox

// ------------------------------------------------------------------------------------------------
void LoadTokenPrivilegesToListBox(HWND hwndCtl, HANDLE hToken)
{
    //     
    ListBox_ResetContent(hwndCtl);

    PTOKEN_PRIVILEGES pTokenPrivileges = NULL;
    BOOL bRet = GetTokenPrivileges(hToken, &pTokenPrivileges); //   

    if (FALSE != bRet)
    {
        TCHAR szName[256];

        for (DWORD i = 0; i < pTokenPrivileges->PrivilegeCount; ++i)
        {
            //  LUID 
            LUID Luid = pTokenPrivileges->Privileges[i].Luid;

            //   
            DWORD cch = _countof(szName);
            LookupPrivilegeName(NULL, &Luid, szName, &cch);

            //   
            DWORD dwAttributes = pTokenPrivileges->Privileges[i].Attributes;

            if (dwAttributes & SE_PRIVILEGE_ENABLED)
            {
                //    ,
                //    
                StringCchCat(szName, _countof(szName), TEXT(" ()"));
            } // if

            //     
            int iItem = ListBox_AddString(hwndCtl, szName);
            //     
            ListBox_SetItemData(hwndCtl, iItem, dwAttributes);
        } // for

        //   
        LocalFree(pTokenPrivileges);
    } // if
} // LoadTokenPrivilegesToListBox
