// Sample3.cpp
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#include <Windows.h>
#include <WindowsX.h>
#include <CommCtrl.h>
#include <tchar.h>
#include <strsafe.h>
#include <LMCons.h>

#include <shlwapi.h>
#pragma comment(lib, "shlwapi.lib")

#include <SecurityLibrary.h>

#include "resource.h"

TCHAR szFileName[MAX_PATH] = TEXT(""); //  /

PSECURITY_DESCRIPTOR pSD = NULL; //   /

//    " "
INT_PTR CALLBACK DialogSecurityProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
//    " "
INT_PTR CALLBACK DialogAceProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

//   WM_INITDIALOG
BOOL DialogSecurity_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam);
//   WM_DESTROY
void DialogSecurity_OnDestroy(HWND hwnd);
//   WM_COMMAND
void DialogSecurity_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
//   WM_NOTIFY
void DialogSecurity_OnNotify(HWND hwnd, LPNMHDR lpnmhdr);

//   WM_INITDIALOG
BOOL DialogAce_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam);
//   WM_COMMAND
void DialogAce_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);

// ,    
void LoadFileSecurityInfo(HWND hwnd);

// ----------------------------------------------------------------------------------------------
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE, LPTSTR lpszCmdLine, int nCmdShow)
{
    if ((NULL != lpszCmdLine) && (_T('\0') != lpszCmdLine[0]))
    {
        //   /   
        StringCchCopy(szFileName, _countof(szFileName), lpszCmdLine);
        //      
        PathUnquoteSpaces(szFileName);

        //    " "
        DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG_SECURITY), NULL, DialogSecurityProc);
    } // if
} // _tWinMain

// ----------------------------------------------------------------------------------------------
INT_PTR CALLBACK DialogSecurityProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
    case WM_INITDIALOG:
    {
        BOOL bRet = HANDLE_WM_INITDIALOG(hwndDlg, wParam, lParam, DialogSecurity_OnInitDialog);
        return SetDlgMsgResult(hwndDlg, uMsg, bRet);
    }

    case WM_DESTROY:
        return HANDLE_WM_DESTROY(hwndDlg, wParam, lParam, DialogSecurity_OnDestroy);

    case WM_CLOSE:
        EndDialog(hwndDlg, IDCLOSE);
        return TRUE;

    case WM_COMMAND:
        HANDLE_WM_COMMAND(hwndDlg, wParam, lParam, DialogSecurity_OnCommand);
        return TRUE;

    case WM_NOTIFY:
        DialogSecurity_OnNotify(hwndDlg, (LPNMHDR)lParam);
        return TRUE;
    } // switch

    return FALSE;
} // DialogSecurityProc

// ----------------------------------------------------------------------------------------------
INT_PTR CALLBACK DialogAceProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
    case WM_INITDIALOG:
    {
        BOOL bRet = HANDLE_WM_INITDIALOG(hwndDlg, wParam, lParam, DialogAce_OnInitDialog);
        return SetDlgMsgResult(hwndDlg, uMsg, bRet);
    }

    case WM_CLOSE:
        EndDialog(hwndDlg, IDCLOSE);
        return TRUE;

    case WM_COMMAND:
        HANDLE_WM_COMMAND(hwndDlg, wParam, lParam, DialogAce_OnCommand);
        return TRUE;
    } // switch

    return FALSE;
} // DialogAceProc

// ----------------------------------------------------------------------------------------------
BOOL DialogSecurity_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    //   /   " "
    SetDlgItemText(hwnd, IDC_EDIT_OBJECT, szFileName);

    //        " "
    SendDlgItemMessage(hwnd, IDC_EDIT_OWNER, EM_LIMITTEXT, (WPARAM)UNLEN, 0L);
    //        "  "
    SendDlgItemMessage(hwnd, IDC_EDIT_NEWOWNER, EM_LIMITTEXT, (WPARAM)UNLEN, 0L);

    //   DACL
    HWND hwndLV = GetDlgItem(hwnd, IDC_DACL);

    //   
    ListView_SetExtendedListViewStyle(hwndLV, LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);

    //       DACL

    LVCOLUMN lvColumns[] = {
        { LVCF_WIDTH | LVCF_TEXT, 0, 100, (LPTSTR)TEXT("") },
        { LVCF_WIDTH | LVCF_TEXT, 0, 200, (LPTSTR)TEXT("") },
        { LVCF_WIDTH | LVCF_TEXT, 0, 170, (LPTSTR)TEXT(" ") },
    };

    for (int i = 0; i < _countof(lvColumns); ++i)
    {
        //  
        ListView_InsertColumn(hwndLV, i, &lvColumns[i]);
    } // for

    //    
    LoadFileSecurityInfo(hwnd);

    return TRUE;
} // DialogSecurity_OnInitDialog

// ----------------------------------------------------------------------------------------------
void DialogSecurity_OnDestroy(HWND hwnd)
{
    //   
    if (NULL != pSD) LocalFree(pSD), pSD = NULL;
} // DialogSecurity_OnDestroy

// ----------------------------------------------------------------------------------------------
void DialogSecurity_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDC_ADD_ACE: //  ACE
    {
        //    " "
        int mdRes = DialogBox(GetWindowInstance(hwnd), MAKEINTRESOURCE(IDD_DIALOG_ACE), hwnd, DialogAceProc);

        if (IDOK == mdRes)
        {
            //    
            LoadFileSecurityInfo(hwnd);
        } // if
    }
    break;

    case IDC_DELETE_ACE:
    {
        //   DACL
        HWND hwndLV = GetDlgItem(hwnd, IDC_DACL);

        for (;;)
        {
            //       DACL
            int iItem = ListView_GetNextItem(hwndLV, -1, LVNI_SELECTED);

            if (iItem == -1) //    
            {
                break; //   
            } // if

            //  ACE   
            DeleteEntryFromDalc(pSD, iItem);
            //      DACL
            ListView_DeleteItem(hwndLV, iItem);
        } // for

        //     /
        SetFileSecurity(szFileName, DACL_SECURITY_INFORMATION, pSD);
    }
    break;

    case IDC_CHANGE_OWNER:
    {
        TCHAR szAccountOwner[UNLEN + 1]; //     
        //         "  "
        GetDlgItemText(hwnd, IDC_EDIT_NEWOWNER, szAccountOwner, _countof(szAccountOwner));

        //    /
        BOOL bRet = SetFileSecurityInfo(szFileName, szAccountOwner, 0, NULL, FALSE);

        if (FALSE != bRet)
        {
            //     "  "
            SetDlgItemText(hwnd, IDC_EDIT_NEWOWNER, NULL);
        } // if
        else
        {
            MessageBox(hwnd, TEXT("   .     ."), NULL, MB_OK | MB_ICONERROR);
        } // else
    }
    break;
    } // switch
} // DialogSecurity_OnCommand

// ----------------------------------------------------------------------------------------------
void DialogSecurity_OnNotify(HWND hwnd, LPNMHDR lpnmhdr)
{
    if (NM_DBLCLK == lpnmhdr->code && IDC_DACL == lpnmhdr->idFrom && NULL != pSD)
    {
        //   DACL
        HWND hwndLV = GetDlgItem(hwnd, IDC_DACL);

        //       DACL
        int iItem = ListView_GetNextItem(hwndLV, -1, LVNI_SELECTED);

        if (iItem != -1)
        {
            ULONG uCount = 0; //     ACE
            PEXPLICIT_ACCESS pEA = NULL; //  ACE

            //    DACL
            BOOL bRet = GetEntriesFromDacl(pSD, &uCount, &pEA);

            if (FALSE != bRet)
            {
                //    " "
                DialogBoxParam(GetWindowInstance(hwnd), MAKEINTRESOURCE(IDD_DIALOG_ACE), hwnd, DialogAceProc, (LPARAM)&pEA[iItem]);

                //   
                LocalFree(pEA);
            } // if
        } // if
    } // if
} // DialogSecurity_OnNotify

// ----------------------------------------------------------------------------------------------

//    /
constexpr DWORD dwPermissions[13] = {
    FILE_TRAVERSE,
    FILE_LIST_DIRECTORY,
    FILE_READ_ATTRIBUTES,
    FILE_READ_EA,
    FILE_ADD_FILE,
    FILE_ADD_SUBDIRECTORY,
    FILE_WRITE_ATTRIBUTES,
    FILE_WRITE_EA,
    FILE_DELETE_CHILD,
    DELETE,
    READ_CONTROL,
    WRITE_DAC,
    WRITE_OWNER
};

//     
constexpr WORD idcPermissions[13] = {
    IDC_FILE_TRAVERSE,
    IDC_FILE_LIST_DIRECTORY,
    IDC_FILE_READ_ATTRIBUTES,
    IDC_FILE_READ_EA,
    IDC_FILE_ADD_FILE,
    IDC_FILE_ADD_SUBDIRECTORY,
    IDC_FILE_WRITE_ATTRIBUTES,
    IDC_FILE_WRITE_EA,
    IDC_FILE_DELETE_CHILD,
    IDC_DELETE,
    IDC_READ_CONTROL,
    IDC_WRITE_DAC,
    IDC_WRITE_OWNER
};

//     grfInheritance
constexpr DWORD dwInherit[7] = {
    NO_INHERITANCE,
    SUB_CONTAINERS_AND_OBJECTS_INHERIT,
    SUB_CONTAINERS_ONLY_INHERIT,
    SUB_OBJECTS_ONLY_INHERIT,
    INHERIT_ONLY | SUB_CONTAINERS_AND_OBJECTS_INHERIT,
    INHERIT_ONLY | SUB_CONTAINERS_ONLY_INHERIT,
    INHERIT_ONLY | SUB_OBJECTS_ONLY_INHERIT
};

//  ,       grfInheritance
constexpr LPCTSTR szInheritText[7] = {
    TEXT("   "),
    TEXT("  ,    "),
    TEXT("     "),
    TEXT("     "),
    TEXT("    "),
    TEXT("  "),
    TEXT("  ")
};

// ----------------------------------------------------------------------------------------------
BOOL DialogAce_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    PEXPLICIT_ACCESS pEA = (PEXPLICIT_ACCESS)lParam; //  ACE
    BOOL fEditable = (NULL == pEA) ? TRUE : FALSE; // ,     ACE

    // /// //

    //   
    DWORD grfAccessMode = (NULL != pEA) ? pEA->grfAccessMode : GRANT_ACCESS;

    //    ""

    HWND hwndCtl = GetDlgItem(hwnd, IDC_ACCESS_MODE);
    EnableWindow(hwndCtl, fEditable);

    int iItem = ComboBox_AddString(hwndCtl, TEXT(""));

    if (iItem != -1)
    {
        ComboBox_SetItemData(hwndCtl, iItem, GRANT_ACCESS);
        if (GRANT_ACCESS == grfAccessMode) ComboBox_SetCurSel(hwndCtl, iItem);
    } // if

    iItem = ComboBox_AddString(hwndCtl, TEXT(""));

    if (iItem != -1)
    {
        ComboBox_SetItemData(hwndCtl, iItem, DENY_ACCESS);
        if (DENY_ACCESS == grfAccessMode) ComboBox_SetCurSel(hwndCtl, iItem);
    } // if

    // /// //

    hwndCtl = GetDlgItem(hwnd, IDC_EDIT_NAME);
    Edit_SetText(hwndCtl, NULL);

    if (NULL != pEA)
    {
        Edit_SetReadOnly(hwndCtl, TRUE);

        LPTSTR lpszName = NULL; //   
        //    
        GetAccountName(pEA->Trustee.ptstrName, &lpszName);

        if (NULL != lpszName)
        {
            //       ""
            Edit_SetText(hwndCtl, lpszName);
            //   
            LocalFree(lpszName);
        } // if
    } // if

    EnableWindow(GetDlgItem(hwnd, IDC_BUTTON_NAME_TEST), fEditable);

    // /// //

    if (NULL != pEA)
    {
        for (int i = 0; i < 13; ++i)
        {
            if (pEA->grfAccessPermissions & dwPermissions[i])
            {
                CheckDlgButton(hwnd, idcPermissions[i], BST_CHECKED);
            } // if

            EnableWindow(GetDlgItem(hwnd, idcPermissions[i]), fEditable);
        } // for
    } // if

    // /// //

    if (FALSE != fEditable) //    ACE
    {
        //   /
        DWORD dwFileAttributes = GetFileAttributes(szFileName);
        //  ,    ACE (  )
        fEditable = ((INVALID_FILE_ATTRIBUTES != dwFileAttributes) && (dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) ? TRUE : FALSE;
    } // if

    // /// //

    //    ""

    DWORD selInheritance = (NULL != pEA) ? (pEA->grfInheritance & (~INHERIT_NO_PROPAGATE)) : SUB_CONTAINERS_AND_OBJECTS_INHERIT;

    hwndCtl = GetDlgItem(hwnd, IDC_INHERIT);
    EnableWindow(hwndCtl, fEditable);

    for (int i = 0; i < 7; ++i)
    {
        int iItem = ComboBox_AddString(hwndCtl, szInheritText[i]);

        if (iItem != -1)
        {
            ComboBox_SetItemData(hwndCtl, iItem, dwInherit[i]);
            if (selInheritance == dwInherit[i]) ComboBox_SetCurSel(hwndCtl, iItem);
        } // if
    } // for

    // /// //

    if ((NULL != pEA) && (pEA->grfInheritance & INHERIT_NO_PROPAGATE))
    {
        CheckDlgButton(hwnd, IDC_CHECK_INHERIT_NO_PROPAGATE, BST_CHECKED);
    } // if

    EnableWindow(GetDlgItem(hwnd, IDC_CHECK_INHERIT_NO_PROPAGATE), fEditable);

    // /// //

    return TRUE;
} // DialogAce_OnInitDialog

// ----------------------------------------------------------------------------------------------
void DialogAce_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDOK:
    {
        HWND hwndCtl = GetDlgItem(hwnd, IDC_EDIT_NAME);

        if ( IsWindowEnabled(hwndCtl) != FALSE ) //   ACE
        {
            PSID pSid = NULL; //    

            int cch = GetWindowTextLength(hwndCtl);

            if (cch > 0)
            {
                LPTSTR lpszName = new TCHAR[cch + 1]; //   

                //       
                GetDlgItemText(hwnd, IDC_EDIT_NAME, lpszName, cch + 1);
                //  SID  
                GetAccountSID(lpszName, &pSid);

                //   
                delete[] lpszName, lpszName = NULL;
            } // if

            if (NULL != pSid)
            {
                EXPLICIT_ACCESS ea;

                ea.Trustee.TrusteeForm = TRUSTEE_IS_SID; //      SID
                ea.Trustee.ptstrName = (LPTSTR)pSid; // SID

                //  

                ea.grfAccessPermissions = 0;

                for (int i = 0; i < 13; ++i)
                {
                    if (IsDlgButtonChecked(hwnd, idcPermissions[i]) == BST_CHECKED)
                    {
                        ea.grfAccessPermissions |= dwPermissions[i];
                    } // if
                } // for

                //   

                hwndCtl = GetDlgItem(hwnd, IDC_ACCESS_MODE);
                ea.grfAccessMode = (ACCESS_MODE)ComboBox_GetItemData(hwndCtl, ComboBox_GetCurSel(hwndCtl));

                // /// //

                hwndCtl = GetDlgItem(hwnd, IDC_INHERIT);
                ea.grfInheritance = (DWORD)ComboBox_GetItemData(hwndCtl, ComboBox_GetCurSel(hwndCtl));

                if ((NO_INHERITANCE != ea.grfInheritance) &&
                    (IsDlgButtonChecked(hwnd, IDC_CHECK_INHERIT_NO_PROPAGATE) == BST_CHECKED))
                {
                    ea.grfInheritance |= INHERIT_NO_PROPAGATE;
                } // if

                // /// //

                if (0 != ea.grfAccessPermissions)
                {
                    //     
                    BOOL bRet = SetFileSecurityInfo(szFileName, NULL, 1, &ea, TRUE);

                    if (FALSE != bRet)
                    {
                        //   
                        EndDialog(hwnd, IDOK);
                    } // if
                } // if

                //   
                LocalFree(pSid);
            } // if
            else
            {
                MessageBox(hwnd, TEXT("    .    ."), NULL, MB_OK | MB_ICONERROR);
            } // if
        } // if
        else
        {
            //   
            EndDialog(hwnd, IDOK);
        } // ese
    }
    break;

    case IDCANCEL:
        EndDialog(hwnd, IDCANCEL);
        break;

    case IDC_BUTTON_NAME_TEST: // 
    {
        int cch = GetWindowTextLength(GetDlgItem(hwnd, IDC_EDIT_NAME));

        if (cch > 0)
        {
            PSID pSid = NULL;

            LPTSTR lpszName = new TCHAR[cch + 1]; //   
            //       
            GetDlgItemText(hwnd, IDC_EDIT_NAME, lpszName, cch + 1);

            //  SID  
            GetAccountSID(lpszName, &pSid);
            //   
            delete[]lpszName, lpszName = NULL;

            if (NULL != pSid)
            {
                //    
                GetAccountName(pSid, &lpszName);

                //       
                SetDlgItemText(hwnd, IDC_EDIT_NAME, lpszName);

                //   
                if (NULL != lpszName) LocalFree(lpszName);

                //   
                LocalFree(pSid);
            } // if
            else
            {
                MessageBox(hwnd, TEXT("    .    ."), NULL, MB_OK | MB_ICONERROR);

                //     ""
                SetDlgItemText(hwnd, IDC_EDIT_NAME, NULL);
            } // if
        } // if
    }
    break;
    } // switch
} // DialogAce_OnCommand

// ----------------------------------------------------------------------------------------------
void LoadFileSecurityInfo(HWND hwnd)
{
    //     " "
    SetDlgItemText(hwnd, IDC_EDIT_OWNER, NULL);

    //   DACL
    HWND hwndLV = GetDlgItem(hwnd, IDC_DACL);
    //      
    ListView_DeleteAllItems(hwndLV);

    //   
    if (NULL != pSD) LocalFree(pSD), pSD = NULL;
    //   
    BOOL bRet = GetFileSecurityDescriptor(szFileName, OWNER_SECURITY_INFORMATION | DACL_SECURITY_INFORMATION, &pSD);

    if (FALSE != bRet)
    {
        LPTSTR lpAccountOwner = NULL; //    

        //     
        bRet = GetOwnerName(pSD, &lpAccountOwner);

        if (FALSE != bRet)
        {
            //        " "
            SetDlgItemText(hwnd, IDC_EDIT_OWNER, lpAccountOwner);
            //   
            LocalFree(lpAccountOwner);
        } // if

        ULONG uCount = 0; //     ACE
        PEXPLICIT_ACCESS pEA = NULL; //  ACE

        //        
        BOOL bRet = GetEntriesFromDacl(pSD, &uCount, &pEA);

        if (FALSE != bRet)
        {
            for (ULONG i = 0; i < uCount; ++i)
            {
                LVITEM lvItem = { LVIF_TEXT | LVIF_PARAM };

                lvItem.iItem = (int)i;

                //   
                lvItem.lParam = (LPARAM)pEA[i].grfAccessPermissions;

                //   ACE
                switch (pEA[i].grfAccessMode)
                {
                case GRANT_ACCESS: 
                    lvItem.pszText = (LPTSTR)TEXT("");
                    break;
                case DENY_ACCESS:
                    lvItem.pszText = (LPTSTR)TEXT("");
                    break;
                } // switch

                //       DACL
                int iItem = ListView_InsertItem(hwndLV, &lvItem);
                if (iItem == -1) continue; //     

                //    
                if (TRUSTEE_IS_SID == pEA[i].Trustee.TrusteeForm)
                {
                    LPTSTR lpszName = NULL; //   

                    //    
                    GetAccountName(pEA[i].Trustee.ptstrName, &lpszName);

                    if (NULL != lpszName)
                    {
                        //         DACL
                        ListView_SetItemText(hwndLV, iItem, 1, lpszName);
                        //   
                        LocalFree(lpszName);
                    } // if
                } // if

                //       
                DWORD grfInheritance = pEA[i].grfInheritance & (~INHERIT_NO_PROPAGATE);

                for (int j = 0; j < _countof(dwInherit); ++j)
                {
                    if (grfInheritance == dwInherit[j]) //  
                    {
                        //      DACL     grfInheritance
                        ListView_SetItemText(hwndLV, iItem, 2, (LPTSTR)szInheritText[j]);

                        break; //   
                    } // if
                } // for
            } // for

            //   
            LocalFree(pEA);
        } // if
    } // if
} // LoadFileSecurityInfo
