// Sample4.cpp
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#include <Windows.h>
#include <tchar.h>
#include <stdio.h>
#include <conio.h>
#include <locale.h>
#include <strsafe.h>
#include <LMCons.h>

#include <shlwapi.h>
#pragma comment(lib, "shlwapi.lib")

#include <SecurityLibrary.h>

typedef BOOL (__stdcall *LPSEARCHFUNC)(LPCTSTR lpszFileName, const LPWIN32_FILE_ATTRIBUTE_DATA lpFileAttributeData, LPVOID lpvParam);

// ,      
BOOL __stdcall FileMove(LPCTSTR lpszFileName, const LPWIN32_FILE_ATTRIBUTE_DATA lpFileAttributeData, LPVOID lpvParam);
// ,      
BOOL __stdcall FileCopy(LPCTSTR lpszFileName, const LPWIN32_FILE_ATTRIBUTE_DATA lpFileAttributeData, LPVOID lpvParam);
// ,      
BOOL __stdcall FileDelete(LPCTSTR lpszFileName, const LPWIN32_FILE_ATTRIBUTE_DATA lpFileAttributeData, LPVOID lpvParam);

// ,      
BOOL FileOperation(LPCTSTR lpszFileName, LPCTSTR lpTargetDirectory, LPSEARCHFUNC lpFunc);

// ,     
BOOL FileSearch(LPCTSTR lpszFileName, LPCTSTR lpszDirName, LPSEARCHFUNC lpSearchFunc, LPVOID lpvParam);

//       
HANDLE LogonUserToLocalComputer();

// ----------------------------------------------------------------------------------------------
int _tmain(int argc, LPTSTR argv[])
{
    _tsetlocale(LC_ALL, TEXT(""));

    if ((4 == argc) && (_tcscmp(argv[1], TEXT("/move")) == 0)) //    
    {
        _tprintf(TEXT(">  \"%s\"   \"%s\\\"\n"), argv[2], argv[3]);

        //  /
        BOOL bRet = FileOperation(argv[2], argv[3], FileMove);

        if (FALSE != bRet) _tprintf(TEXT("> !\n"));
        else _tprintf(TEXT("> : %d\n"), GetLastError());
    } // if
    else if ((4 == argc) && (_tcscmp(argv[1], TEXT("/copy")) == 0)) //    
    {
        _tprintf(TEXT(">  \"%s\"   \"%s\\\"\n"), argv[2], argv[3]);

        //  /
        BOOL bRet = FileOperation(argv[2], argv[3], FileCopy);

        if (FALSE != bRet) _tprintf(TEXT("> !\n"));
        else _tprintf(TEXT("> : %d\n"), GetLastError());
    } // if
    else if ((3 == argc) && (_tcscmp(argv[1], TEXT("/delete")) == 0)) //    
    {
        _tprintf(TEXT(">  \"%s\"\n"), argv[2]);

        //  /
        BOOL bRet = FileOperation(argv[2], NULL, FileDelete);

        if (FALSE != bRet) _tprintf(TEXT("> !\n"));
        else _tprintf(TEXT("> : %d\n"), GetLastError());
    } // if
    else
    {
        _tprintf(TEXT("/move <filename> <target>\n\n\
\t<filename> -     \n\
\t<target> - ,       \n\n"));

        _tprintf(TEXT("/copy <filename> <target>\n\n\
\t<filename> -     \n\
\t<target> - ,       \n\n"));

        _tprintf(TEXT("/delete <filename>\n\n\
\t<filename> -     \n\n"));
    } // else
} // _tmain

// ----------------------------------------------------------------------------------------------
BOOL __stdcall FileMove(LPCTSTR lpszFileName, const LPWIN32_FILE_ATTRIBUTE_DATA lpFileAttributeData, LPVOID lpvParam)
{
    LPCTSTR lpTargetDirectory = (LPCTSTR)lpvParam; // ,     /

    TCHAR szNewFileName[MAX_PATH]; //   /
    StringCchPrintf(szNewFileName, _countof(szNewFileName), TEXT("%s\\%s"), (LPCTSTR)lpTargetDirectory, PathFindFileName(lpszFileName));

    if (lpFileAttributeData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) //   
    {
        //    ( )
        BOOL bRet = CreateDirectoryEx(lpszFileName, szNewFileName, NULL);

        if ((FALSE != bRet) || (GetLastError() == ERROR_ALREADY_EXISTS)) // (!) :   ,     .
        {
            //    
            bRet = FileSearch(TEXT("*"), lpszFileName, FileMove, szNewFileName);
        } // if

        if (FALSE != bRet)
        {
            //  
            bRet = RemoveDirectory(lpszFileName);
        } // if

        return bRet;
    } // if

    return MoveFileEx(lpszFileName, szNewFileName, MOVEFILE_REPLACE_EXISTING | MOVEFILE_COPY_ALLOWED);
} // FileMove

// ----------------------------------------------------------------------------------------------
BOOL __stdcall FileCopy(LPCTSTR lpszFileName, const LPWIN32_FILE_ATTRIBUTE_DATA lpFileAttributeData, LPVOID lpvParam)
{
    LPCTSTR lpTargetDirectory = (LPCTSTR)lpvParam; // ,     /

    TCHAR szNewFileName[MAX_PATH]; //   /
    StringCchPrintf(szNewFileName, _countof(szNewFileName), TEXT("%s\\%s"), (LPCTSTR)lpTargetDirectory, PathFindFileName(lpszFileName));

    if (lpFileAttributeData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) //   
    {
        //    ( )
        BOOL bRet = CreateDirectoryEx(lpszFileName, szNewFileName, NULL);

        if ((FALSE != bRet) || (GetLastError() == ERROR_ALREADY_EXISTS)) // (!) :   ,     . 
        {
            //    
            bRet = FileSearch(TEXT("*"), lpszFileName, FileCopy, szNewFileName);
        } // if

        return bRet;
    } // if

    //  
    return CopyFile(lpszFileName, szNewFileName, FALSE);
} // FileCopy

// ----------------------------------------------------------------------------------------------
BOOL __stdcall FileDelete(LPCTSTR lpszFileName, const LPWIN32_FILE_ATTRIBUTE_DATA lpFileAttributeData, LPVOID /*lpvParam*/)
{
    if (lpFileAttributeData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) //   
    {
        //  
        BOOL bRet = RemoveDirectory(lpszFileName);

        if ((FALSE == bRet) && (GetLastError() == ERROR_DIR_NOT_EMPTY)) // (!) :   ,       .
        {
            //    
            bRet = FileSearch(TEXT("*"), lpszFileName, FileDelete, NULL);

            if (FALSE != bRet)
            {
                //    
                bRet = RemoveDirectory(lpszFileName);
            } // if
        } // if

        return bRet;
    } // if

    //  
    return DeleteFile(lpszFileName);
} // FileDelete

// ----------------------------------------------------------------------------------------------
BOOL FileOperation(LPCTSTR lpszFileName, LPCTSTR lpTargetDirectory, LPSEARCHFUNC lpFunc)
{
    if (NULL != lpTargetDirectory)
    {
        DWORD dwFileAttributes = GetFileAttributes(lpTargetDirectory);

        if (INVALID_FILE_ATTRIBUTES == dwFileAttributes) // (!) 
        {
            return FALSE;
        } // if
        else if ((dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0) // (!)   
        {
            SetLastError(ERROR_PATH_NOT_FOUND);
            return FALSE;
        } // if
    } // if

    WIN32_FILE_ATTRIBUTE_DATA fad;

    //    /
    BOOL bRet = GetFileAttributesEx(lpszFileName, GetFileExInfoStandard, &fad);

    if (FALSE != bRet)
    {
        for (int i = 0; i < 3; ++i) //    = 3
        {
            //    /
            bRet = lpFunc(lpszFileName, &fad, (LPVOID)lpTargetDirectory);

            //    
            DWORD dwError = (FALSE == bRet) ? GetLastError() : ERROR_SUCCESS;

            //  
            RevertToSelf();

            if (ERROR_ACCESS_DENIED == dwError) // (!) :   
            {
                _tprintf(TEXT(">   .\n\n"));

                //    
                HANDLE hToken = LogonUserToLocalComputer();

                if (NULL != hToken)
                {
                    //  
                    ImpersonateLoggedOnUser(hToken);
                    //   
                    CloseHandle(hToken);
                } // if
                else
                {
                    break; // (!)   
                } // else
            } // if
            else
            {
                SetLastError(dwError);
                break; // (!)   
            } // else
        } // for
    } // if

    return bRet;
} // FileOperation

// ----------------------------------------------------------------------------------------------
BOOL FileSearch(LPCTSTR lpszFileName, LPCTSTR lpszDirName, LPSEARCHFUNC lpSearchFunc, LPVOID lpvParam)
{
    WIN32_FIND_DATA fd;
    TCHAR szFileName[MAX_PATH];

    //   
    StringCchPrintf(szFileName, MAX_PATH, TEXT("%s\\%s"), lpszDirName, lpszFileName);

    //  
    HANDLE hFindFile = FindFirstFile(szFileName, &fd);
    if (INVALID_HANDLE_VALUE == hFindFile) return FALSE;

    BOOL bRet = TRUE;

    for (BOOL bFindNext = TRUE; FALSE != bFindNext; bFindNext = FindNextFile(hFindFile, &fd))
    {
        if (_tcscmp(fd.cFileName, TEXT(".")) == 0 || _tcscmp(fd.cFileName, TEXT("..")) == 0)
        {
            /*      */
            continue;
        } // if

        //     
        StringCchPrintf(szFileName, MAX_PATH, TEXT("%s\\%s"), lpszDirName, fd.cFileName);

        bRet = lpSearchFunc(szFileName, (LPWIN32_FILE_ATTRIBUTE_DATA)&fd, lpvParam);
        if (FALSE == bRet) break; //  
    } // for

    FindClose(hFindFile); //  
    return bRet;
} // FileSearch

// ----------------------------------------------------------------------------------------------
static inline bool getline(LPTSTR lpszDest, DWORD cchDest, TCHAR rch = _T('\0'))
{
    lpszDest[0] = _T('\0'); //  

    //  ,
    //     Enter

    for (;;)
    {
        //     
        TCHAR ch = _gettch();

        if (_T('\r') == ch)
        {
            _puttch(_T('\n'));
            break;
        } // if
        else if (_T('\b') == ch)
        {
            size_t cch = _tcslen(lpszDest);

            if (cch > 0)
            {
                //  

                _puttch(_T('\b'));
                _puttch(_T(' '));
                _puttch(_T('\b'));

                lpszDest[cch - 1] = _T('\0');
            } // if
        } // if
        else
        {
            if (_T('\0') == rch)
            {
                //     
                _puttch(ch);
            } // if
            else
            {
                //     
                _puttch(rch);
            } // else

            //    
            StringCchCatN(lpszDest, cchDest, &ch, 1);
        } // else
    } // for

    return (_T('\0') != lpszDest[0]);
} // getline

// ----------------------------------------------------------------------------------------------
HANDLE LogonUserToLocalComputer()
{
    TCHAR szUserName[UNLEN + 1]; //  
    TCHAR szPassword[51]; // 

    for (int j = 0; j < 3; ++j) //    = 3
    {
        _tprintf(TEXT(">  : "));
        if ( !getline(szUserName, _countof(szUserName)) )
        {
            break; // (!)   
        } // if

        _tprintf(TEXT("> : "));
        getline(szPassword, _countof(szPassword), _T('*'));

        _tprintf(TEXT("\n"));

        //    
        HANDLE hToken = OpenUserToken(szUserName, TEXT("."), szPassword,
            LOGON32_LOGON_INTERACTIVE, TOKEN_QUERY | TOKEN_IMPERSONATE, NULL, TokenImpersonation, SecurityImpersonation);

        if (NULL != hToken)
        {
            return hToken; //    
        } // if
    } // for

    return NULL;
} // LogonUserToLocalComputer
