// LsaPolicy.cpp
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#include <Windows.h>
#include <NTSecAPI.h>

// ------------------------------------------------------------------------------------------------
static inline void InitUnicodeString(LPCWSTR lpString, PLSA_UNICODE_STRING pUnicodeString)
{
    size_t cch = wcslen(lpString); //   

    pUnicodeString->Length = (USHORT)(cch * sizeof(WCHAR));
    pUnicodeString->MaximumLength = (USHORT)((cch + 1) * sizeof(WCHAR));
    pUnicodeString->Buffer = (PWSTR)lpString;
} // InitUnicodeString

// ------------------------------------------------------------------------------------------------
LSA_HANDLE OpenLocalPolicy(ACCESS_MASK DesiredAccess)
{
    LSA_HANDLE lsahPolicy;
    LSA_OBJECT_ATTRIBUTES ObjectAttributes;

    //   LSA_OBJECT_ATTRIBUTES 
    ZeroMemory(&ObjectAttributes, sizeof(ObjectAttributes));

    //     
    NTSTATUS ntsResult = LsaOpenPolicy(NULL, &ObjectAttributes, DesiredAccess, &lsahPolicy);

    //    
    SetLastError(LsaNtStatusToWinError(ntsResult));

    //     
    return LSA_SUCCESS(ntsResult) ? lsahPolicy : NULL;
} // OpenLocalPolicy

// ------------------------------------------------------------------------------------------------
BOOL AddAccountRight(LSA_HANDLE lsahPolicy, PSID pSid, LPCWSTR UserRight)
{
    LSA_UNICODE_STRING right;
    InitUnicodeString(UserRight, &right);

    //  /  
    NTSTATUS ntsResult = LsaAddAccountRights(lsahPolicy, pSid, &right, 1);

    //    
    SetLastError(LsaNtStatusToWinError(ntsResult));

    return LSA_SUCCESS(ntsResult) ? TRUE : FALSE;
} // AddAccountRight

// ------------------------------------------------------------------------------------------------
BOOL RemoveAccountRight(LSA_HANDLE lsahPolicy, PSID pSid, LPCWSTR UserRight)
{
    LSA_UNICODE_STRING right;
    InitUnicodeString(UserRight, &right);

    //  /  
    NTSTATUS ntsResult = LsaRemoveAccountRights(lsahPolicy, pSid, FALSE, &right, 1);

    //    
    SetLastError(LsaNtStatusToWinError(ntsResult));

    return LSA_SUCCESS(ntsResult) ? TRUE : FALSE;
} // RemoveAccountRight
