// SecurityLibrary.h
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#pragma once

#if !defined(__SECURITY_LIBRARY_H__)
#define __SECURITY_LIBRARY_H__

#include <sddl.h>
#include <NTSecAPI.h>
#include <AclAPI.h>

// ,   SID  
BOOL GetAccountSID(LPCTSTR lpAccountName, PSID *ppSid);
// ,     SID
BOOL GetWellKnownSID(WELL_KNOWN_SID_TYPE WellKnownSidType, PSID pDomainSid, PSID *ppSid);
// ,       SID
BOOL GetAccountName(PSID pSid, LPTSTR *lpName);

// ,      
BOOL GetOwnerName(PSECURITY_DESCRIPTOR pSD, LPTSTR *lpName);
// ,     DACL
BOOL GetEntriesFromDacl(PSECURITY_DESCRIPTOR pSD, PULONG pcCountOfEntries, PEXPLICIT_ACCESS *pListOfEntries);
// ,     DACL
BOOL DeleteEntryFromDalc(PSECURITY_DESCRIPTOR pSD, DWORD dwIndex);

// ,     
BOOL GetObjectSecurityDescriptor(HANDLE hObject, SECURITY_INFORMATION RequestedInformation, PSECURITY_DESCRIPTOR *ppSD);
//        
BOOL SetObjectSecurityInfo(HANDLE hObject, LPCTSTR lpAccountOwner, ULONG cCountOfEntries, PEXPLICIT_ACCESS pListOfEntries, BOOL bMergeEntries);

// ,   
BOOL GetFileSecurityDescriptor(LPCTSTR lpFileName, SECURITY_INFORMATION RequestedInformation, PSECURITY_DESCRIPTOR *ppSD);
//      
BOOL SetFileSecurityInfo(LPCTSTR lpFileName, LPCTSTR lpAccountOwner, ULONG cCountOfEntries, PEXPLICIT_ACCESS pListOfEntries, BOOL bMergeEntries);

// ,      
LSA_HANDLE OpenLocalPolicy(ACCESS_MASK DesiredAccess);

// ,      
BOOL AddAccountRight(LSA_HANDLE lsahPolicy, PSID pSid, LPCWSTR UserRight);
// ,      
BOOL RemoveAccountRight(LSA_HANDLE lsahPolicy, PSID pSid, LPCWSTR UserRight);

// ,    
HANDLE OpenProcessTokenByProcessId(DWORD dwProcessId, DWORD dwDesiredAccess);
//,   
HANDLE OpenToken(DWORD dwDesiredAccess);
// ,   
HANDLE OpenUserToken(LPCTSTR lpszUsername, LPCTSTR lpszDomain, LPCTSTR lpszPassword, DWORD dwLogonType,
    DWORD dwDesiredAccess, PSECURITY_ATTRIBUTES lpTokenAttributes, TOKEN_TYPE TokenType, SECURITY_IMPERSONATION_LEVEL ImpersonationLevel);

// ,     SID 
BOOL GetTokenUser(HANDLE hToken, PSID *ppSid);
// ,      
BOOL GetTokenGroups(HANDLE hToken, PTOKEN_GROUPS *pTokenGroups);
// ,     
BOOL GetTokenPrivileges(HANDLE hToken, PTOKEN_PRIVILEGES *pTokenPrivileges);
// ,   
BOOL IsPrivilegeExists(HANDLE hToken, LPCTSTR lpszPrivilegeName);
// ,    
BOOL IsPrivilegesExists(HANDLE hToken, LPCTSTR names[], DWORD dwCount, BOOL bAllPrivileges);
// ,   
BOOL IsPrivilegeEnabled(HANDLE hToken, LPCTSTR lpszPrivilegeName);
//     
BOOL PrivilegesCheck(HANDLE hToken, LPCTSTR names[], DWORD dwCount, BOOL bSetAllNecessary, PPRIVILEGE_SET *pPrivSet);
// ,   
BOOL EnablePrivilege(HANDLE hToken, LPCTSTR lpszPrivilegeName, BOOL bEnable);
//     
BOOL AdjustPrivileges(HANDLE hToken, LPCTSTR names[], DWORD NewState[], DWORD dwCount);
// ,      
BOOL DisableAllPrivileges(HANDLE hToken);

#endif /* __SECURITY_LIBRARY_H__ */
