// Sample1 (pipe).cpp
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#include <Windows.h>
#include <WindowsX.h>
#include <CommCtrl.h>
#include <tchar.h>
#include <strsafe.h>
#include <process.h>

#include <SampleIPCLibrary.h>

#define IDC_EDIT_MESSAGES           2001
#define IDC_EDIT_TEXT               2002
#define IDC_RBUTTON_WM_SETTEXT      2003
#define IDC_RBUTTON_WM_COPYDATA     2004
#define IDC_RBUTTON_CLIPBOARD       2005
#define IDC_RBUTTON_PIPE            2006

#define MAX_TEXT                    1024

HWND hWnd = NULL; //   

HKEY hKey = NULL; //   ,
    //        

HANDLE hReadPipe = NULL; //      
HANDLE hWritePipe = NULL; //      

HANDLE hStopper = NULL; //     ThreadFuncClipboard   
HANDLE hSendEvent = NULL; //         
HANDLE hMutex = NULL; //       

HANDLE hThreads[2]; //   

//    
LRESULT CALLBACK MyWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

// ,      
//  ,       
BOOL PreTranslateMessage(LPMSG lpMsg);

//   WM_CREATE
BOOL OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct);
//   WM_DESTROY
void OnDestroy(HWND hwnd);
//   WM_SIZE
void OnSize(HWND hwnd, UINT state, int cx, int cy);
//   WM_SETTEXT
void OnSetText(HWND hwnd, LPCTSTR lpszText);
//   WM_COPYDATA
BOOL OnCopyData(HWND hwnd, HWND hwndFrom, PCOPYDATASTRUCT pcds);

// ,     
BOOL RegisterApplication();
// ,       
void UregisterApplication();

//       
void SendText(LPCTSTR lpText, DWORD cchText, BOOL fCopyData);
//      
void SendTextToClipboard(LPCTSTR lpText, DWORD cchText);
//     
void SendTextToPipe(LPCTSTR lpText, DWORD cchText);

// ,  
BOOL DuplicateHandle(DWORD dwProcessId, HANDLE hSourceHandle, LPHANDLE lpTargetHandle, DWORD dwDesiredAccess);

//  ,      
unsigned __stdcall ThreadFuncClipboard(void *lpParameter);
//  ,     
unsigned __stdcall ThreadFuncPipe(void *lpParameter);

// ----------------------------------------------------------------------------------------------
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE, LPTSTR lpszCmdLine, int nCmdShow)
{
    //      ...

    WNDCLASSEX wcex = { sizeof(WNDCLASSEX) };

    wcex.style = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
    wcex.lpfnWndProc = MyWindowProc; //  
    wcex.hInstance = hInstance;
    wcex.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
    wcex.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
    wcex.lpszClassName = TEXT("MyWindowClass"); //  
    wcex.hIconSm = LoadIcon(NULL, IDI_APPLICATION);

    if (0 == RegisterClassEx(&wcex)) //  
    {
        //      
        return -1; //   
    } // if

    //   
    //    
    LoadLibrary(TEXT("ComCtl32.dll"));

    //        

    hWnd = CreateWindowEx(0, TEXT("MyWindowClass"), TEXT("Sample1"), WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, 0, 900, 500, NULL, NULL, hInstance, NULL);

    if (NULL == hWnd)
    {
        //     
        return -1; //   
    } // if

    //     
    BOOL bRet = RegisterApplication();

    if (FALSE == bRet)
    {
        //       
        return -1; //   
    } // if

    ShowWindow(hWnd, nCmdShow); //   

    //     ...

    MSG  msg;

    while ((bRet = GetMessage(&msg, NULL, 0, 0)) != FALSE)
    {
        if (bRet == -1)
        {
            /*        */
        } // if
        else if (!PreTranslateMessage(&msg))
        {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        } // else
    } // while

    //       
    UregisterApplication();

    return (int)msg.wParam;
} // _tWinMain

// ----------------------------------------------------------------------------------------------
LRESULT CALLBACK MyWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hWnd, WM_CREATE, OnCreate);
        HANDLE_MSG(hWnd, WM_DESTROY, OnDestroy);
        HANDLE_MSG(hWnd, WM_SIZE, OnSize);
        HANDLE_MSG(hWnd, WM_SETTEXT, OnSetText);
    case WM_COPYDATA:
        return HANDLE_WM_COPYDATA(hWnd, wParam, lParam, OnCopyData);
    } // switch

    //   
    //    
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
} // MyWindowProc

// ----------------------------------------------------------------------------------------------
BOOL PreTranslateMessage(LPMSG lpMsg)
{
    if ((WM_KEYDOWN == lpMsg->message) && (VK_RETURN == lpMsg->wParam)) //   Enter
    {
        HWND hwndCtl = GetDlgItem(hWnd, IDC_EDIT_TEXT);

        if (GetFocus() == hwndCtl) //     
        {
            if (GetKeyState(VK_CONTROL) < 0) //   Ctrl
            {
                //    
                //      
                Edit_ReplaceSel(hwndCtl, TEXT("\r\n"));
            } // if
            else
            {
                TCHAR szText[MAX_TEXT];

                //     
                DWORD cch = Edit_GetText(hwndCtl, szText, _countof(szText));

                if (cch > 0)
                {
                    //   
                    Edit_SetText(hwndCtl, NULL);

                    //  

                    if (IsDlgButtonChecked(hWnd, IDC_RBUTTON_WM_SETTEXT) == BST_CHECKED)
                    {
                        StringCchCat(szText, _countof(szText), TEXT("\r\n\r\n-- -- --\r\n\
    WN_SETTEXT\r\n\r\n-- -- -- \r\n"));

                        SendText(szText, _tcslen(szText), FALSE);
                    } // if
                    else if (IsDlgButtonChecked(hWnd, IDC_RBUTTON_WM_COPYDATA) == BST_CHECKED)
                    {
                        StringCchCat(szText, _countof(szText), TEXT("\r\n\r\n-- -- --\r\n\
    WM_COPYDATA\r\n\r\n-- -- --\r\n"));

                        SendText(szText, _tcslen(szText), TRUE);
                    } // if
                    else if (IsDlgButtonChecked(hWnd, IDC_RBUTTON_CLIPBOARD) == BST_CHECKED)
                    {
                        StringCchCat(szText, _countof(szText), TEXT("\r\n\r\n-- -- --\r\n\
    \r\n\r\n-- -- --\r\n"));

                        SendTextToClipboard(szText, _tcslen(szText));
                    } // if
                    else if (IsDlgButtonChecked(hWnd, IDC_RBUTTON_PIPE) == BST_CHECKED)
                    {
                        StringCchCat(szText, _countof(szText), TEXT("\r\n\r\n-- -- --\r\n\
   \r\n\r\n-- -- --\r\n"));

                        SendTextToPipe(szText, _tcslen(szText));
                    } // if
                } // if
            } // else

            return TRUE;
        } // if
    } // if

    return FALSE;
} // PreTranslateMessage

// ----------------------------------------------------------------------------------------------
BOOL OnCreate(HWND hwnd, LPCREATESTRUCT lpCreateStruct)
{
    //   
    BOOL bRet = CreatePipe(&hReadPipe, &hWritePipe, NULL, 0);

    if (FALSE == bRet)
    {
        //     
        return FALSE;
    } // if

    //      ThreadFuncClipboard   
    hStopper = CreateEventEx(NULL, NULL, CREATE_EVENT_MANUAL_RESET, EVENT_ALL_ACCESS);

    //          
    hSendEvent = CreateEventEx(NULL, NULL, 0, EVENT_ALL_ACCESS);

    //        
    hMutex = CreateMutexEx(NULL, TEXT("MutexClipboard"), 0, MUTEX_ALL_ACCESS);

    //  ,        
    hThreads[0] = (HANDLE)_beginthreadex(NULL, 0, ThreadFuncClipboard, NULL, 0, NULL);
    //  ,       
    hThreads[1] = (HANDLE)_beginthreadex(NULL, 0, ThreadFuncPipe, NULL, 0, NULL);

    // /// //

    //   
    CreateWindowEx(0, TEXT("Button"), TEXT(" "), WS_CHILD | WS_VISIBLE | BS_GROUPBOX,
        10, 10, 300, 130, hwnd, (HMENU)0, lpCreateStruct->hInstance, NULL);

    //  

    CreateWindowEx(0, TEXT("Button"), TEXT("  WM_SETTEXT"), WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON,
        20, 30, 280, 25, hwnd, (HMENU)IDC_RBUTTON_WM_SETTEXT, lpCreateStruct->hInstance, NULL);

    CreateWindowEx(0, TEXT("Button"), TEXT("  WM_COPYDATA"), WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON,
        20, 55, 280, 25, hwnd, (HMENU)IDC_RBUTTON_WM_COPYDATA, lpCreateStruct->hInstance, NULL);

    CreateWindowEx(0, TEXT("Button"), TEXT(" "), WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON,
        20, 80, 280, 25, hwnd, (HMENU)IDC_RBUTTON_CLIPBOARD, lpCreateStruct->hInstance, NULL);

    CreateWindowEx(0, TEXT("Button"), TEXT(" "), WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON,
        20, 105, 280, 25, hwnd, (HMENU)IDC_RBUTTON_PIPE, lpCreateStruct->hInstance, NULL);

    CheckRadioButton(hwnd, IDC_RBUTTON_WM_SETTEXT, IDC_RBUTTON_PIPE, IDC_RBUTTON_WM_SETTEXT);


    DWORD dwStyle = WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_HSCROLL | ES_MULTILINE | ES_AUTOHSCROLL | ES_AUTOVSCROLL;

    //    
    CreateWindowEx(WS_EX_STATICEDGE, TEXT("Edit"), TEXT(""), dwStyle | ES_READONLY,
        320, 10, 400, 400, hwnd, (HMENU)IDC_EDIT_MESSAGES, lpCreateStruct->hInstance, NULL);

    //   
    HWND hwndCtl = CreateWindowEx(WS_EX_CLIENTEDGE, TEXT("Edit"), TEXT(""), dwStyle,
        320, 420, 400, 100, hwnd, (HMENU)IDC_EDIT_TEXT, lpCreateStruct->hInstance, NULL);

    //     
    Edit_LimitText(hwndCtl, MAX_TEXT);

    //    
    SetFocus(hwndCtl);

    return TRUE;
} // OnCreate

// ----------------------------------------------------------------------------------------------
void OnDestroy(HWND hwnd)
{
    //    ,
    //    ThreadFuncClipboard
    SetEvent(hStopper);
    //       ,
    //    ThreadFuncPipe
    CloseHandle(hWritePipe);

    //    
    WaitForMultipleObjects(_countof(hThreads), hThreads, TRUE, INFINITE);

    //       
    CloseHandle(hReadPipe);

    //      
    CloseHandle(hStopper);
    //           
    CloseHandle(hSendEvent);
    //   
    CloseHandle(hMutex);

    // /// //

    PostQuitMessage(0); //   WM_QUIT
} // OnDestroy

// ----------------------------------------------------------------------------------------------
void OnSize(HWND hwnd, UINT state, int cx, int cy)
{
    if (state != SIZE_MINIMIZED)
    {
        //     
        MoveWindow(GetDlgItem(hwnd, IDC_EDIT_MESSAGES), 320, 10, cx - 320, cy - 130, TRUE);
        //    
        MoveWindow(GetDlgItem(hwnd, IDC_EDIT_TEXT), 320, cy - 110, cx - 330, 100, TRUE);
    } // if
} // OnSize

// ----------------------------------------------------------------------------------------------
void OnSetText(HWND hwnd, LPCTSTR lpszText)
{
    HWND hwndCtl = GetDlgItem(hwnd, IDC_EDIT_MESSAGES);

    //      
    Edit_SetSel(hwndCtl, Edit_GetTextLength(hwndCtl), -1);

    //     
    Edit_ReplaceSel(hwndCtl, lpszText);
} // OnSetText

// ----------------------------------------------------------------------------------------------
BOOL OnCopyData(HWND hwnd, HWND hwndFrom, PCOPYDATASTRUCT pcds)
{
    OnSetText(hwnd, (LPCTSTR)pcds->lpData);
    return TRUE;
} // OnCopyData

// ----------------------------------------------------------------------------------------------
BOOL RegisterApplication()
{
    //      HKEY_CURRENT_USER\Software\Sample1 (OS-Lab6)

    DWORD dwDisposition;

    LONG lStatus = RegCreateKeyEx(HKEY_CURRENT_USER, TEXT("Software\\Sample1 (OS-Lab6)"),
        0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition);

    if (ERROR_SUCCESS == lStatus)
    {
        //    
        DWORD dwProcessId = GetCurrentProcessId();

        HKEY  hSubKey = NULL; //    ,
            //      
        TCHAR szSubKey[20]; //    

        //     
        StringCchPrintf(szSubKey, _countof(szSubKey), TEXT("%d"), dwProcessId);

        //    
        lStatus = RegCreateKey(hKey, szSubKey, &hSubKey);

        if (ERROR_SUCCESS == lStatus)
        {
            //    
            RegSetValueEx(hSubKey, NULL, 0, REG_DWORD, (LPBYTE)&dwProcessId, sizeof(DWORD));

            //     
            RegSetValueEx(hSubKey, TEXT("hWnd"), 0, REG_BINARY, (LPBYTE)&hWnd, sizeof(HWND));

            //            
            RegSetValueEx(hSubKey, TEXT("hSendEvent"), 0, REG_BINARY, (LPBYTE)&hSendEvent, sizeof(HANDLE));

            //        
            RegSetValueEx(hSubKey, TEXT("hWritePipe"), 0, REG_BINARY, (LPBYTE)&hWritePipe, sizeof(HANDLE));

            //    
            RegCloseKey(hSubKey), hSubKey = NULL;

            return TRUE;
        } // if

        //   
        RegCloseKey(hKey), hKey = NULL;
    } // if

    return FALSE;
} // RegisterApplication

// ----------------------------------------------------------------------------------------------
void UregisterApplication()
{
    if (NULL != hKey)
    {
        DWORD cSubKeys = 0; //   

        //    
        LSTATUS lStatus = RegQueryInfoKey(hKey, NULL, NULL, NULL, &cSubKeys, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

        if ((ERROR_SUCCESS == lStatus) && (cSubKeys < 2))
        {
            //   
            RegDeleteTree(hKey, NULL);
            //  
            RegDeleteKey(HKEY_CURRENT_USER, TEXT("Software\\Sample1 (OS-Lab6)"));
        } // if
        else
        {
            TCHAR szSubKey[20]; //    ,
                //     

            //     
            StringCchPrintf(szSubKey, _countof(szSubKey), TEXT("%d"), GetCurrentProcessId());

            //   
            RegDeleteKey(hKey, szSubKey);
        } // else

        //   
        RegCloseKey(hKey), hKey = NULL;
    } // if
} // UregisterApplication

// ----------------------------------------------------------------------------------------------
void SendText(LPCTSTR lpText, DWORD cchText, BOOL fCopyData)
{
    if ((NULL != lpText) && (cchText > 0))
    {
        DWORD cSubKeys = 0; //   

        //    
        LSTATUS lStatus = RegQueryInfoKey(hKey, NULL, NULL, NULL, &cSubKeys, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

        if ((ERROR_SUCCESS == lStatus) && (cSubKeys > 0))
        {
            HKEY  hSubKey = NULL; //    
            TCHAR szSubKey[20]; //    

            //    ...

            for (DWORD dwIndex = 0; dwIndex < cSubKeys; ++dwIndex)
            {
                //       dwIndex
                DWORD cchSubKey = _countof(szSubKey);
                lStatus = RegEnumKeyEx(hKey, dwIndex, szSubKey, &cchSubKey, NULL, NULL, NULL, NULL);

                if (ERROR_SUCCESS == lStatus)
                {
                    //   
                    lStatus = RegOpenKeyEx(hKey, szSubKey, 0, KEY_QUERY_VALUE, &hSubKey);
                } // if

                if (ERROR_SUCCESS == lStatus)
                {
                    HWND hRecvWnd; //   
                    DWORD cb = sizeof(HWND);

                    //    
                    lStatus = RegQueryValueEx(hSubKey, TEXT("hWnd"), NULL, NULL, (LPBYTE)&hRecvWnd, &cb);

                    if (ERROR_SUCCESS == lStatus)
                    {
                        if (FALSE != fCopyData)
                        {
                            //  
                            COPYDATASTRUCT cds;

                            cds.lpData = (PVOID)lpText;
                            cds.cbData = (cchText + 1) * sizeof(TCHAR);
                            cds.dwData = 0;

                            //   WM_COPYDATA
                            SendMessage(hRecvWnd, WM_COPYDATA, (WPARAM)hWnd, (LPARAM)&cds);
                        } // if
                        else
                        {
                            //   WM_SETTEXT
                            SendMessage(hRecvWnd, WM_SETTEXT, 0, (LPARAM)lpText);
                        } // else
                    } // if

                    //    
                    RegCloseKey(hSubKey), hSubKey = NULL;
                } // if
            } // for
        } // if
    } // if
} // SendText

// ----------------------------------------------------------------------------------------------
void SendTextToClipboard(LPCTSTR lpText, DWORD cchText)
{
    if ((NULL != lpText) && (cchText > 0))
    {
        //   ,
        //    
        WaitForSingleObject(hMutex, INFINITE);

        //     
        BOOL bRet = WriteClipboard(lpText);

        if (FALSE != bRet)
        {
            //     

            DWORD cSubKeys = 0; //   

            //    
            LSTATUS lStatus = RegQueryInfoKey(hKey, NULL, NULL, NULL, &cSubKeys, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

            if ((ERROR_SUCCESS == lStatus) && (cSubKeys > 0))
            {
                HKEY  hSubKey = NULL; //    
                TCHAR szSubKey[20]; //    

                //    ...

                for (DWORD dwIndex = 0; dwIndex < cSubKeys; ++dwIndex)
                {
                    //       dwIndex
                    DWORD cchSubKey = _countof(szSubKey);
                    lStatus = RegEnumKeyEx(hKey, dwIndex, szSubKey, &cchSubKey, NULL, NULL, NULL, NULL);

                    if (ERROR_SUCCESS == lStatus)
                    {
                        //   
                        lStatus = RegOpenKeyEx(hKey, szSubKey, 0, KEY_QUERY_VALUE, &hSubKey);
                    } // if

                    if (ERROR_SUCCESS == lStatus)
                    {
                        DWORD dwProcessId = 0; //  
                        HANDLE hEvent = NULL; //          

                        //   
                        DWORD cb = sizeof(DWORD);
                        lStatus = RegQueryValueEx(hSubKey, NULL, NULL, NULL, (LPBYTE)&dwProcessId, &cb);

                        if (ERROR_SUCCESS == lStatus)
                        {
                            //       
                            cb = sizeof(HANDLE);
                            lStatus = RegQueryValueEx(hSubKey, TEXT("hSendEvent"), NULL, NULL, (LPBYTE)&hEvent, &cb);
                        } // if

                        if (ERROR_SUCCESS == lStatus)
                        {
                            //       
                            BOOL bRet = DuplicateHandle(dwProcessId, hEvent, &hEvent, GENERIC_WRITE);

                            if (FALSE != bRet)
                            {
                                //    
                                SetEvent(hEvent);
                                //   
                                CloseHandle(hEvent);
                            } // if
                        } // if

                        //    
                        RegCloseKey(hSubKey), hSubKey = NULL;
                    } // if
                } // for
            } // if
        } // if

        //  
        ReleaseMutex(hMutex);
    } // if
} // SendTextToClipboard

// ----------------------------------------------------------------------------------------------
void SendTextToPipe(LPCTSTR lpText, DWORD cchText)
{
    if ((NULL != lpText) && (cchText > 0))
    {
        DWORD cSubKeys = 0; //   

        //    
        LSTATUS lStatus = RegQueryInfoKey(hKey, NULL, NULL, NULL, &cSubKeys, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

        if ((ERROR_SUCCESS == lStatus) && (cSubKeys > 0))
        {
            HKEY  hSubKey = NULL; //    
            TCHAR szSubKey[20]; //    

            //    ...

            for (DWORD dwIndex = 0; dwIndex < cSubKeys; ++dwIndex)
            {
                //       dwIndex
                DWORD cchSubKey = _countof(szSubKey);
                lStatus = RegEnumKeyEx(hKey, dwIndex, szSubKey, &cchSubKey, NULL, NULL, NULL, NULL);

                if (ERROR_SUCCESS == lStatus)
                {
                    //   
                    lStatus = RegOpenKeyEx(hKey, szSubKey, 0, KEY_QUERY_VALUE, &hSubKey);
                } // if

                if (ERROR_SUCCESS == lStatus)
                {
                    DWORD dwProcessId = 0; //  
                    HANDLE hPipe = NULL; //      

                    //   
                    DWORD cb = sizeof(DWORD);
                    lStatus = RegQueryValueEx(hSubKey, NULL, NULL, NULL, (LPBYTE)&dwProcessId, &cb);

                    if (ERROR_SUCCESS == lStatus)
                    {
                        //       
                        cb = sizeof(HANDLE);
                        lStatus = RegQueryValueEx(hSubKey, TEXT("hWritePipe"), NULL, NULL, (LPBYTE)&hPipe, &cb);
                    } // if

                    if (ERROR_SUCCESS == lStatus)
                    {
                        //       
                        BOOL bRet = DuplicateHandle(dwProcessId, hPipe, &hPipe, GENERIC_WRITE);

                        if (FALSE != bRet)
                        {
                            //      
                            WriteFile(hPipe, lpText, (cchText + 1) * sizeof(TCHAR), &cb, NULL);
                            //   
                            CloseHandle(hPipe);
                        } // if
                    } // if

                    //    
                    RegCloseKey(hSubKey), hSubKey = NULL;
                } // if
            } // for
        } // if
    } // if
} // SendTextToPipe

// ------------------------------------------------------------------------------------------------
BOOL DuplicateHandle(DWORD dwProcessId, HANDLE hSourceHandle, LPHANDLE lpTargetHandle, DWORD dwDesiredAccess)
{
    BOOL bRet = FALSE;

    //  
    HANDLE hProcess = OpenProcess(PROCESS_DUP_HANDLE, FALSE, dwProcessId);

    if (NULL != hProcess)
    {
        //   
        bRet = DuplicateHandle(hProcess, hSourceHandle, GetCurrentProcess(), lpTargetHandle, dwDesiredAccess, FALSE, 0);

        //   
        CloseHandle(hProcess);
    } // if

    return bRet;
} // DuplicateHandle

// ------------------------------------------------------------------------------------------------
unsigned __stdcall ThreadFuncClipboard(void *lpParameter)
{
    //  
    HANDLE hEvents[2] = { hStopper, hSendEvent };

    TCHAR szText[MAX_TEXT];

    for (;;)
    {
        //     
        DWORD dwResult = WaitForMultipleObjects(2, hEvents, FALSE, INFINITE);

        if (WAIT_OBJECT_0 == dwResult) //  
        {
            break; // (!)   
        } // if
        else if ((WAIT_OBJECT_0 + 1) == dwResult) //  
        {
            //   ,
            //    
            WaitForSingleObject(hMutex, INFINITE);

            //     
            BOOL bRet = ReadClipboard(szText, _countof(szText));

            if (FALSE != bRet)
            {
                SendMessage(hWnd, WM_SETTEXT, 0, (LPARAM)szText);
            } // if

            ReleaseMutex(hMutex); //  
        } // if
    } // for

    return 0;
} // ThreadFuncClipboard

// ------------------------------------------------------------------------------------------------
unsigned __stdcall ThreadFuncPipe(void *lpParameter)
{
    TCHAR szText[MAX_TEXT];
    DWORD nBytesRead;

    for (;;)
    {
        //      
        BOOL bRet = ReadFile(hReadPipe, szText, sizeof(szText), &nBytesRead, NULL);

        if (FALSE != bRet)
        {
            SendMessage(hWnd, WM_SETTEXT, 0, (LPARAM)szText);
        } // if
        else if (ERROR_BROKEN_PIPE == GetLastError())
        {
            /*    */
            break; // (!)   
        } // if
    } // for

    return 0;
} // ThreadFuncPipe
