// Sample2 (client).cpp
//
// Copyright (c), ..  (andrei.glukhoedov@gmail.com)
//

#include <Windows.h>
#include <tchar.h>
#include <stdio.h>
#include <conio.h>
#include <strsafe.h>
#include <locale.h>

#include <SampleIPCLibrary.h>

#pragma pack(push, 1)

struct REQUEST
{
    DWORD dwProcessId;
    DWORD dwIndex;
}; // struct REQUEST

#pragma pack(pop)

// ------------------------------------------------------------------------------------------------
int _tmain(int argc, LPCTSTR argv[])
{
    _tsetlocale(LC_ALL, TEXT(""));

    _tprintf(TEXT(">   :\n"));
    _tprintf(TEXT("> \n"));

    for (int i = 0; i < argc; ++i)
    {
        _tprintf(TEXT("> %s\n"), argv[i]);
    } // for

    _tprintf(TEXT("\n"));

    if (2 == argc)
    {
        if (_tcsicmp(argv[1], TEXT("/mailslot")) == 0) //  
        {
            HANDLE hWriteMailslot = INVALID_HANDLE_VALUE; //    
            HANDLE hReadMailslot = INVALID_HANDLE_VALUE; //    

            //    
            hWriteMailslot = CreateFile(TEXT("\\\\.\\mailslot\\SampleMailslot\\0"), GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);

            if (INVALID_HANDLE_VALUE == hWriteMailslot)
            {
                //     
                return -1; //   
            } // if

            TCHAR szNameMailslot[256]; //    

            //     
            StringCchPrintf(szNameMailslot, _countof(szNameMailslot), TEXT("\\\\.\\mailslot\\SampleMailslot\\%u"), GetCurrentProcessId());


            SECURITY_DESCRIPTOR sd; //  

            //   
            BOOL bRet = InitializeSecurityDescriptor(&sd, SECURITY_DESCRIPTOR_REVISION);

            if (FALSE != bRet)
                bRet = SetSecurityDescriptorDacl(&sd, TRUE, NULL, FALSE);

            if (FALSE != bRet)
            {
                SECURITY_ATTRIBUTES sa = { sizeof(SECURITY_ATTRIBUTES) };
                sa.lpSecurityDescriptor = &sd;

                //    
                hReadMailslot = CreateMailslot(szNameMailslot, 0, MAILSLOT_WAIT_FOREVER, &sa);
            } // if

            if (INVALID_HANDLE_VALUE == hReadMailslot)
            {
                //     
                return -1; //   
            } // if

            // /// //

            REQUEST Request; // 

            Request.dwProcessId = GetCurrentProcessId();
            Request.dwIndex = 0;

            DWORD nBytes;
            TCHAR szResponse[100]; // 

            for (;;)
            {
                //     
                BOOL bRet = TransactMailslot(hWriteMailslot,
                    &Request, sizeof(Request), hReadMailslot, szResponse, sizeof(szResponse), &nBytes);

                if (FALSE != bRet)
                {
                    if (_T('\0') == szResponse[0])
                    {
                        break; //   
                    } // if

                    _tprintf(TEXT("> %d %s\n"), (Request.dwIndex + 1), szResponse);

                    Sleep(200);
                } // if
                else
                {
                    _tprintf(TEXT("> : %d\n"), GetLastError());
                    break;
                } // if

                ++Request.dwIndex;
            } // for

            // /// //

            //    
            CloseHandle(hReadMailslot);
            //    
            CloseHandle(hWriteMailslot);
        } // if
        else if (_tcsicmp(argv[1], TEXT("/pipe")) == 0) //  
        {
            REQUEST Request; // 

            Request.dwProcessId = GetCurrentProcessId();
            Request.dwIndex = 0;

            DWORD nBytes;
            TCHAR szResponse[100]; // 

            for (;;)
            {
                //     
                BOOL bRet = CallNamedPipe(TEXT("\\\\.\\pipe\\SamplePipe"),
                    &Request, sizeof(Request), szResponse, sizeof(szResponse), &nBytes, NMPWAIT_WAIT_FOREVER);

                if (FALSE != bRet)
                {
                    if (_T('\0') == szResponse[0])
                    {
                        break; //   
                    } // if

                    _tprintf(TEXT("> %d %s\n"), (Request.dwIndex + 1), szResponse);

                    Sleep(200);
                } // if
                else
                {
                    _tprintf(TEXT("> : %d\n"), GetLastError());
                    break;
                } // if

                ++Request.dwIndex;
            } // for
        } // if
        else if (_tcsicmp(argv[1], TEXT("/share")) == 0) //    
        {
            HANDLE hShared = NULL; //   
            HANDLE hSharedEventServer = NULL; //         
            HANDLE hSharedEventClient = NULL; //         
            HANDLE hSharedMutex = NULL; //        (  )

            //   
            hShared = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, TEXT("Global\\SampleShared"));

            if (NULL == hShared)
            {
                //     
                return -1; //   
            } // if

            //          
            hSharedEventServer = OpenEvent(SYNCHRONIZE|EVENT_MODIFY_STATE, FALSE, TEXT("Global\\SampleSharedEventServer"));

            if (NULL == hSharedEventServer)
            {
                //    
                return -1; //   
            } // if

            //          
            hSharedEventClient = OpenEvent(SYNCHRONIZE|EVENT_MODIFY_STATE, FALSE, TEXT("Global\\SampleSharedEventClient"));

            if (NULL == hSharedEventClient)
            {
                //    
                return -1; //   
            } // if

            //        
            hSharedMutex = OpenMutex(SYNCHRONIZE, FALSE, TEXT("Global\\SampleSharedMutex"));

            if (NULL == hSharedMutex)
            {
                //    
                return -1; //   
            } // if

            // /// //

            REQUEST Request; // 

            Request.dwProcessId = GetCurrentProcessId();
            Request.dwIndex = 0;

            TCHAR szResponse[100]; // 

            for (;;)
            {
                //   ,
                //    
                WaitForSingleObject(hSharedMutex, INFINITE);

                //  
                BOOL bRet = WriteFileMapping(hShared, &Request, sizeof(Request));

                if (FALSE != bRet)
                {
                    //     
                    SetEvent(hSharedEventServer);

                    //  
                    WaitForSingleObject(hSharedEventClient, INFINITE);

                    //  
                    bRet = ReadFileMapping(hShared, szResponse, sizeof(szResponse));
                } // if

                ReleaseMutex(hSharedMutex); //  

                if (FALSE != bRet)
                {
                    if (_T('\0') == szResponse[0])
                    {
                        break; //   
                    } // if

                    _tprintf(TEXT("> %d %s\n"), (Request.dwIndex + 1), szResponse);

                    Sleep(200);
                } // if
                else
                {
                    _tprintf(TEXT("> : %d\n"), GetLastError());
                    break;
                } // if

                ++Request.dwIndex;
            } // for

            // /// //

            //    
            CloseHandle(hShared);
            //   
            CloseHandle(hSharedEventServer);
            //   
            CloseHandle(hSharedEventClient);
            //   
            CloseHandle(hSharedMutex);
        } // if
    } // if
} // _tmain
